#ifndef FEATURE_H
#define FEATURE_H

class Feature;
#include "hiddennode.h"
#include <cassert>
#include <utility>
#include <cstdlib>
#include <iostream>
#include <vector>
using namespace std;
/**
	@author Jan Niehues <jan@niehues.info>
*/
class Feature{

private:
  //pair < vector<double> , vector<double> > derivation;
public:
    Feature();

    virtual ~Feature();

  /**
   * @return pair<double,double>
   * @param  ToNode
   */
  virtual pair<double,double> GetMessage (const HiddenNode * ToNode ) const;

  virtual SparseArray GetDerivation (const HiddenNode * ToNode) const;

  inline virtual int GetType() const { return 0;};
  /**
   */
  virtual void CalcMessages ( );

  virtual void CalcDerivations();

  /**
   * @return vector<double>
   */
  virtual vector<double> GetExpectationValue();

  /**
   * @return vector<double>
   */
  virtual vector<double> GetExampleValue();
};

#endif
