#ifndef FEATURESET_H
#define FEATURESET_H

class FeatureSet;
#include "graph.h"
#include <vector>
#include "featuresetiterator.h"
#include <cassert>
/**
	@author Jan Niehues <jan@niehues.info>
*/
class FeatureSet{
public:
	FeatureSet();
    FeatureSet(const char* ParamFile, vector<double> & newScalingFactores);

    virtual ~FeatureSet();
  /**
   * @param  G
   */
  virtual void GenerateFeatures (Graph * G, int offset, int numberOfFeatures);

  /**
   * @param newScalingFactors
   */
  virtual void SetScalingFactors(vector<double> & ScalingFactors);

  /**
   * @return int
   */
  virtual int GetNumberOfScalingFactors();


  /**
   * @return FeatureSetIterator
   */
  virtual FeatureSetIterator * GetIterator ( ) const;


   virtual void RemoveFeatures();

  /**
   */
   virtual void EstimateScalingFactores();

   /**
    * @return vector<double>
    */

   virtual vector<double> GetEstimatedDerivations() const {vector<double> t;return t;};


   virtual void OutputScalingFactors();
};

#endif
