#ifndef FERTILITYFEATURE_H
#define FERTILITYFEATURE_H

#include <feature.h>
#include <hiddennode.h>
#include <cassert>
#include <cstdlib>
#include <iostream>
#include <math.h>
#include <map>
#include <vector>
/**
	@author Jan Niehues <jan@niehues.info>
*/
class FertilityFeature : public Feature
{

    private:
	vector<HiddenNode*> nodes;
	double *ScalingFactors;
	int number;
	int numberOfGIZAFeatures;
	vector<double> GIZAFeatureValue;
	vector<double> GIZAScaledFeatureValue;
	map<const HiddenNode*,pair<double,double> > messages;
	int type;
	int offset;
	int numberOfAllFeatures;
	int gizaIndex;
	map<const HiddenNode*,SparseArray> derivations;

public:
    FertilityFeature();

    ~FertilityFeature();
    void Init(vector<HiddenNode*> n, double* SFactors, int num, vector<double> & GIZAFert, double GIZASF,int GIZAnumber, int type,int off, int nOfAllF,int gIndex);
  /**
   * @return double
   * @param  ToNode
   */
   pair<double,double> GetMessage (const HiddenNode * ToNode ) const;
   SparseArray GetDerivation (const HiddenNode * ToNode) const;
  inline virtual int GetType() const { return type;};

  /**	
   */
  void CalcMessages ( );


  void CalcDerivations();

  /**
   * @return vector<double>
   */
  vector<double> GetExpectationValue();

  /**
   * @return vector<double>
   */
  vector<double> GetExampleValue();


};

#endif
