#ifndef FERTILITYFEATURESETITERATOR_H
#define FERTILITYFEATURESETITERATOR_H


#include <fertilityfeature.h>
#include <featuresetiterator.h>
#include <cassert>
/**
	@author Jan Niehues <jan@niehues.info>
*/
class FertilityFeatureSetIterator : public FeatureSetIterator
{
private:
	int index;
	int set; // 0 = Sourcefeatures; 1 = Targetfeatures
	int SourceLength;
	int TargetLength;
	FertilityFeature * source;
	FertilityFeature * target;
public:
    FertilityFeatureSetIterator(int SLength, int TLength, FertilityFeature *S, FertilityFeature *T);

    ~FertilityFeatureSetIterator();
    inline bool end() const {return set && (index == TargetLength);};
    inline void next() { if(!set && (index == SourceLength - 1)) {index = 0; set = 1;}else {index++;}};
    inline Feature * feature() const {
//	cout << "Set: " << set << " index: " << index << endl;
	assert(((set) && (index < TargetLength)) ||((!set)&&(index < SourceLength)));
	if(set) {
	  //cout << "Output Target Word: " << index << endl;
		return &target[index];
	} else {
	  //cout << "Output Source Word: " << index << endl;
		return &source[index];
	}
    }
};

#endif
