#ifndef FERTILITYLOPFEATURE_H
#define FERTILITYLOPFEATURE_H

#include <feature.h>


#include <hiddennode.h>
#include <map>

using namespace std;
/**
	@author Jan Niehues <jan@niehues.info>
*/
class FertilityLOPFeature : public Feature
{
private:
	int numberOfExperts;
	double * expertWeights;
	vector<HiddenNode*> nodes;
	double *ScalingFactors;
	int number;
	int numberOfGIZAFeatures;
	map<const HiddenNode*,pair<double,double> > messages;
	int type;
	int offset;
	int numberOfAllFeatures;
	int gizaIndex;
	map<const HiddenNode*,SparseArray> derivations;
	double * potentialValues;
	double * ScaledFeatureValues;

public:
    FertilityLOPFeature();

    ~FertilityLOPFeature();

    void Init(vector<HiddenNode*> n, double* SFactors, int num, vector<double> & GIZAFert, double * GIZASF,int GIZAnumber, int type,int off, int nOfAllF,int gIndex, int numberOfExp, double *ExpWeight);
  /**
   * @return double
   * @param  ToNode
   */
   pair<double,double> GetMessage (const HiddenNode * ToNode ) const;
   SparseArray GetDerivation (const HiddenNode * ToNode) const;
  inline virtual int GetType() const { return type;};

  /**	
   */
  void CalcMessages ( );


  void CalcDerivations();

  /**
   * @return vector<double>
   */
  vector<double> GetExpectationValue();

  /**
   * @return vector<double>
   */
  vector<double> GetExampleValue();



};

#endif
