#ifndef FIRSTORDERFEATURE_H
#define FIRSTORDERFEATURE_H

#include <feature.h>
#include <hiddennode.h>
#include <cassert>
#include <cstdlib>
#include <iostream>
#include <utility>
#include <cmath>
/**
	@author Jan Niehues <jan@niehues.info>
 */
class FirstOrderFeature : public Feature
{
	private:
		pair<HiddenNode*,HiddenNode*> nodes;
		int number;
		double * ScalingFactors;
		double dynamicScalingFactor;
		pair<double,double> m1;
		pair<double,double> m2;
		SparseArray der1;
		SparseArray der2;
		vector<int> dynamicScalingIndizes;
		int offset;
		int dynamicOffset;
		int numberOfAllFeatures;
	public:
		FirstOrderFeature();

		~FirstOrderFeature();
		void Init( pair<HiddenNode*,HiddenNode*> n, double* SFactors, int num, vector<double> dynScalingFactor, vector<int> dynScalingIndex,int offS, int dynOffSet,int nOfAllF);
 /**
		 * @return double
		 * @param  ToNode
  */
		pair<double,double> GetMessage (const HiddenNode * ToNode ) const;
		SparseArray GetDerivation (const HiddenNode * ToNode) const;

		inline virtual int GetType() const { return 4;};
  /**
   */
		void CalcMessages ( );

		void CalcDerivations();


  /**
		 * @return vector<double>
   */
		vector<double> GetExpectationValue();

  /**
		 * @return vector<double>
   */
		vector<double> GetExampleValue();

		vector<double> GetDynamicExpectationValue();
		vector<double> GetDynamicExampleValue();
		vector<int> GetDynamicSFIndex();
};

#endif
