#ifndef FIRSTORDERFEATURESETITERATOR_H
#define FIRSTORDERFEATURESETITERATOR_H

#include <firstorderfeature.h>
#include <featuresetiterator.h>
#include <cassert>
#include <vector>
/**
	@author Jan Niehues <jan@niehues.info>
*/
class FirstOrderFeatureSetIterator : public FeatureSetIterator
{
private:
  int setIndex;
    int index;
  vector<int> Length;
  vector<FirstOrderFeature *> features;
public:
    FirstOrderFeatureSetIterator(const vector<int> & L, const vector<FirstOrderFeature*> & p);

    ~FirstOrderFeatureSetIterator();
    inline bool end() const {return setIndex >= features.size();};
    inline void next() {index++;while((setIndex < features.size())&&(index >= Length[setIndex])){index = 0; setIndex++;}};
    inline Feature * feature() const {
	assert(setIndex < features.size());
	assert(index < Length[setIndex]);
	return &(features[setIndex])[index];
    }
};

#endif
