#ifndef FIRSTORDERLOPFEATURE_H
#define FIRSTORDERLOPFEATURE_H

#include <feature.h>

#define NUMBER_OF_FOF 3

/**
	@author Jan Niehues <jan@niehues.info>
*/
class FirstOrderLOPFeature : public Feature
{
private:
		int numberOfExperts;
		double * expertWeights;
		pair<HiddenNode*,HiddenNode*> nodes;
		int number;
		double * ScalingFactors;
		double * scaledFeatureValues;
		double * potentialValues;
		pair<double,double> m1;
		pair<double,double> m2;
		SparseArray der1;
		SparseArray der2;
		vector<int> dynamicScalingIndizes;
		int offset;
		int dynamicOffset;
		int numberOfAllFeatures;

public:
    FirstOrderLOPFeature();

    ~FirstOrderLOPFeature();
		void Init( pair<HiddenNode*,HiddenNode*> n, double* SFactors, int num, vector<double *> dynScalingFactor, vector<int> dynScalingIndex,int offS, int dynOffSet,int nOfAllF,int numberOfExp,double * expWeight);
 /**
		 * @return double
		 * @param  ToNode
  */
		pair<double,double> GetMessage (const HiddenNode * ToNode ) const;
		SparseArray GetDerivation (const HiddenNode * ToNode) const;

		inline virtual int GetType() const { return 4;};
  /**
   */
		void CalcMessages ( );

		void CalcDerivations();


  /**
		 * @return vector<double>
   */
		vector<double> GetExpectationValue();

  /**
		 * @return vector<double>
   */
		vector<double> GetExampleValue();

};

#endif
