#ifndef FIRSTORDERLOPFEATURESETITERATOR_H
#define FIRSTORDERLOPFEATURESETITERATOR_H

#include <featuresetiterator.h>
#include <firstorderlopfeature.h>

/**
	@author Jan Niehues <jan@niehues.info>
*/
class FirstOrderLOPFeatureSetIterator : public FeatureSetIterator
{
private:
	int setIndex;
	int index;
	vector<int> Length;
	vector<FirstOrderLOPFeature *> features;
public:
    FirstOrderLOPFeatureSetIterator(const vector<int> & L, const vector<FirstOrderLOPFeature*> & p);

    ~FirstOrderLOPFeatureSetIterator();
   inline bool end() const {return setIndex >= features.size();};
    inline void next() {index++;while((setIndex < features.size())&&(index >= Length[setIndex])){index = 0; setIndex++;}};
    inline Feature * feature() const {
	assert(setIndex < features.size());
	assert(index < Length[setIndex]);
	return &(features[setIndex])[index];
    }
};

#endif
