#ifndef GRAPHITERATOR_H
#define GRAPHITERATOR_H

#include <hiddennode.h>
#include <cassert>
/**
	@author Jan Niehues <jan@niehues.info>
*/
class GraphIterator
{
private:
	int index;
	int SourceLength;
	int TargetLength;
	HiddenNode * nodes;

public:
    GraphIterator(int SLength, int TLength,HiddenNode* p);

    ~GraphIterator();

    inline bool end() const {return index >= SourceLength * TargetLength;};
    inline void next() { index++;};
    inline HiddenNode * node() const {
	assert(index < SourceLength * TargetLength); 
	return &nodes[index];
	};
};

#endif
