#ifndef HIDDENNODE_H
#define HIDDENNODE_H

/**
	@author Jan Niehues <jan@niehues.info>
*/

struct SparseArray {
	double * data;
	int * index;
	int size;
};
class HiddenNode;
#include "feature.h"
#include <vector>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <cmath>
using namespace std;
class HiddenNode{
private:
	vector<Feature*> Connections;
	vector<pair<float,float> > messages;
	int givenValue;
	int staticNode;
	pair<double,double> staticMessage;
	pair<string,string> words;
public:
	HiddenNode();
	~HiddenNode();
	pair<double,double> GetMessage(Feature *ToNode) const;
	void CalcMessages();
	// creates an Sparsearry; has to be deleted by the caller
	SparseArray GetDerivation(int size) const;
	pair<double,double> GetBelief() const;
	void AddConnection(Feature *ToNode);
	void Display(ofstream * out);
	inline void SetGivenValue(int value) {givenValue = value;};
	inline int GetGivenValue() const {return givenValue;};
	void SetStaticNode(int value);
	inline int IsStatic() {return staticNode;};
	inline void SetWords(string source, string target) {words = make_pair(source,target);};
	inline pair<string,string> GetWords() {return words;};
};

#endif
