#ifndef LOCALFEATURE_H
#define LOCALFEATURE_H


#include <feature.h>
#include <hiddennode.h>
#include <cstdlib>
#include <iostream>
#include <math.h>
/**
	@author Jan Niehues <jan@niehues.info>
*/

using namespace std;
class LocalFeature : public Feature
{
    private:
	HiddenNode *node;
	double *p;
	double *ScalingFactors;
	double *FeatureValue;
	vector<double> dynamicScalingFactor;
	vector<int> dynamicScalingIndex;
	int number;
	int offset;
	int numberOfAllFeatures;
	pair<double,double> message;
	SparseArray derivation;
	int kernelType;
	pair<double,double> kernelValue;
	double gamma;

	void PreCalcMessage();

public:
    LocalFeature();
    ~LocalFeature();
    void Init(HiddenNode * n,double *probability, double* SFactors, int num,vector<double> dynScalingFactor, vector <int> dynScalingIndex,int off, int numberOfAF);
  /**
   * @return double
   * @param  ToNode
   */
   inline pair<double,double> GetMessage (const HiddenNode * ToNode ) const {return message;};

  inline SparseArray GetDerivation (const HiddenNode * ToNode) const {return derivation;};
   inline int GetType() const { return 1;};

  /**
   */
  void CalcMessages ( );

void CalcDerivations();
  /**
   * @return vector<double>
   */
  vector<double> GetExpectationValue();

  /**
   * @return double
   */
  vector<double> GetExampleValue();
  /**
   * @return vector<double>
   */
  vector<double> GetDynamicExpectationValue();

  /**
   * @return double
   */
  vector<double> GetDynamicExampleValue();
  /**
   * @return vector<double>
   */
  vector<int> GetDynamicSFIndex();

};

#endif
