#ifndef LOCALFEATURESETITERATOR_H 
#define LOCALFEATURESETITERATOR_H

#include <localfeatureset.h>
#include <featuresetiterator.h>
#include <cassert>

#include <utils.h>
/**
	@author Jan Niehues <jan@niehues.info>
*/
class LocalFeatureSetIterator : public FeatureSetIterator
{
private:
	int index;
	int SourceLength;
	int TargetLength;
	LocalFeature * features;

public:
    LocalFeatureSetIterator(int SLength, int TLength,LocalFeature* p);

    ~LocalFeatureSetIterator();

    inline bool end() const {return index >= SourceLength * TargetLength;};
    inline void next() { index++;};
    inline Feature * feature() const {
	assert(index < SourceLength * TargetLength);
	return &features[index];
	};
};

#endif
