#ifndef LOCALLOPFEATURE_H
#define LOCALLOPFEATURE_H

#include <feature.h>

/**
	@author Jan Niehues <jan@niehues.info>
*/
class LocalLOPFeature : public Feature
{
private:
	int numberOfExperts;
	double * expertWeights;/**< Weights for the different experts */ 
	HiddenNode *node;
	double *p;
	double *ScalingFactors;
	double * scaledFeatureValue;
	double *FeatureValue;
	vector<double* > dynamicScalingFactor;
	vector<int> dynamicScalingIndex;
	int number;
	int offset;
	int numberOfAllFeatures;
	pair<double,double> message;
	SparseArray derivation;

	void PreCalcMessage();

public:
    LocalLOPFeature();

    ~LocalLOPFeature();


    void Init(HiddenNode * n,double *probability, double* SFactors, int num,vector<double*> dynScalingFactor, vector <int> dynScalingIndex,int off, int numberOfAF,int numberOfExperts, double * expertWeights);

  /**
   */
  void CalcMessages ( );

  /**
   * @return double
   * @param  ToNode
   */
   inline pair<double,double> GetMessage (const HiddenNode * ToNode ) const {return message;};

  /**
   * @return vector<double>
   */
  vector<double> GetExpectationValue();

  /**
   * @return double
   */
  vector<double> GetExampleValue();
   inline int GetType() const { return 1;};


  inline SparseArray GetDerivation (const HiddenNode * ToNode) const {return derivation;};

void CalcDerivations();


};

#endif
