#ifndef LOCALLOPFEATURESETITERATOR_H
#define LOCALLOPFEATURESETITERATOR_H

#include <featuresetiterator.h>
#include <locallopfeature.h>
/**
	@author Jan Niehues <jan@niehues.info>
*/
class LocalLOPFeatureSetIterator : public FeatureSetIterator
{
private:
	int index;
	int SourceLength;
	int TargetLength;
	LocalLOPFeature * features;

public:
    LocalLOPFeatureSetIterator(int SLength, int TLength,LocalLOPFeature* p);

    ~LocalLOPFeatureSetIterator();

    inline bool end() const {return index >= SourceLength * TargetLength;};
    inline void next() { index++;};
    inline Feature * feature() const {
	assert(index < SourceLength * TargetLength);
	return &features[index];
	};
};

#endif
