#ifndef LOPOPTIMIZERAER_H
#define LOPOPTIMIZERAER_H

#include <optimizer.h>

/**
	@author Jan Niehues <jan@niehues.info>
*/
class LOPOptimizerAER : public Optimizer
{
private:
		int numberOfExperts;
		double * weights;
		double * bestWeights;
		double * unconstrainedWeights;
		vector <FeatureSet *> FeatureSets;
		int TruePositiveP;
		int FalsePositiveP;
		int TruePositiveS;
		int FalsePositiveS;
		int SLinks;
		int PLinks;
		int deleteCounts;
		double SmoothedTruePositiveP;
		double SmoothedFalsePositiveP;
		double SmoothedTruePositiveS;
		double SmoothedFalsePositiveS;
		double alpha;
		int iteration;
		int bestIteration;
		double bestAER;
		double * FalsePositivePDerivation;
		double * TruePositivePDerivation;
		double * FalsePositiveSDerivation;
		double * TruePositiveSDerivation;
		double * learnRate;

public:
    LOPOptimizerAER(vector <FeatureSet *> FSets,double * w,char * LearnRateFile,int numberOfExperts);

    ~LOPOptimizerAER();
	void EvalSentence(Graph * G);
	virtual void Estimate();
	void OutputBest();
	void CheckScalingFactors();

};

#endif
