#ifndef LOPOPTIMIZERALL_H
#define LOPOPTIMIZERALL_H

#include <optimizer.h>

/**
	@author Jan Niehues <jan@niehues.info>
*/
class LOPOptimizerAll : public Optimizer
{
private:
		int numberOfExperts;
		int numberOfParts;
		double * weights;
		double * bestWeights;
		int * parts;
		vector <FeatureSet *> FeatureSets;
		int TruePositiveP;
		int FalsePositiveP;
		int TruePositiveS;
		int FalsePositiveS;
		int SLinks;
		int PLinks;
		int deleteCounts;
		int iteration;
		int bestIteration;
		double bestAER;
		void CalcWeights();

public:
    LOPOptimizerAll(vector <FeatureSet *> FSets,double * w,char * LearnRateFile,int numberOfExperts);

    ~LOPOptimizerAll();
	void EvalSentence(Graph * G);
	virtual void Estimate();
	void OutputBest();
	void CheckScalingFactors();

};

#endif
