#ifndef LOPOPTIMIZERML_H
#define LOPOPTIMIZERML_H

#include <optimizer.h>
#include <climits>
#include <cfloat>
#include <graph.h>
#include <featureset.h>
/**
	@author Jan Niehues <jan@niehues.info>
*/
class LOPOptimizerML : public Optimizer
{
	vector <FeatureSet *> FeatureSets;
	double * learnRate;
	double * weights;
	int numberOfExperts;
	int bestCorrectLink;
	int bestCorrectNoLink;
	int bestFailedLink;
	int bestFailedNoLink;
	double bestLogProbCorrect;
	double bestLogProbBest;
	double * bestWeights;
	int bestIteration;

	int Sent;
	double logProbCorrect;
	double logProbBest;
	int CorrectLink;
	int FailedLink;
	int CorrectNoLink;
	int FailedNoLink;
	double *  EstimatedDerivations;
	double * oldEstimatedDerivations;
	int iteration;
	double lRate;
	double * unconstrainedWeights;

public:
    LOPOptimizerML(vector <FeatureSet *> FSets,double * w,char * LearnRateFile,int numberOfExperts);

    ~LOPOptimizerML();
	void EvalSentence(Graph * G);
	void Estimate();
	void OutputBest();
	void CheckScalingFactors();

};

#endif
