#ifndef OPTIMIZERAER_H
#define OPTIMIZERAER_H

#include <optimizer.h>
#include <graphiterator.h>

class OptimizerAER : public Optimizer
{
	protected:
		vector <FeatureSet *> FeatureSets;
		int TruePositiveP;
		int FalsePositiveP;
		int TruePositiveS;
		int FalsePositiveS;
		int SLinks;
		int PLinks;
		int TruePositivePCV;
		int FalsePositivePCV;
		int TruePositiveSCV;
		int FalsePositiveSCV;
		int SLinksCV;
		int PLinksCV;
		int deleteCounts;
		double SmoothedTruePositiveP;
		double SmoothedFalsePositiveP;
		double SmoothedTruePositiveS;
		double SmoothedFalsePositiveS;
		int numberOfAllFeatures;
		double alpha;
		int iteration;
		int bestIteration;
		double bestAER;
		vector<double> FalsePositivePDerivation;
		vector<double> TruePositivePDerivation;
		vector<double> FalsePositiveSDerivation;
		vector<double> TruePositiveSDerivation;
		vector < vector<double> > ScalingFactors;
		vector < vector<double> > bestScalingFactors;
		vector <vector<double> > learnRate;
	public:
		OptimizerAER(vector <FeatureSet *> FSets,vector < vector<double> > SFactors,char * Learnratefile);
		void EvalSentence(Graph * G);
		virtual void Estimate();
		void OutputBest();
		void EvalCVSentence(Graph * G);
		void CheckScalingFactors();
		void CheckScalingFactorsWithCV();
};


#endif
