
#include "optimizeraermap.h"

OptimizerAERMAP::OptimizerAERMAP(vector <FeatureSet *> FSets,vector < vector<double> > SFactors,char * learnRateFile)
 : OptimizerAER(FSets,SFactors,learnRateFile){

}


OptimizerAERMAP::~OptimizerAERMAP()
{
}

void OptimizerAERMAP::Estimate(){

	int index = 0;
	//cout << "Derivations:" << endl;
	cout << "New Scaling Factors: " << endl;
	for(int i = 0; i < ScalingFactors.size(); i++) {
		for(int j = 0; j < ScalingFactors[i].size();j++) {
    //cout << TruePositiveSDerivation[index] << "*(" << SmoothedFalsePositiveS << " + " <<SLinks<< ")";
    //cout << " + " << TruePositivePDerivation[index] << " *( " << SmoothedFalsePositiveP << " + " << SLinks <<" )";
    //cout << " - " << FalsePositiveSDerivation[index] << " * " << SmoothedTruePositiveS;
    //cout << " - " << FalsePositivePDerivation[index] << " * " << SmoothedTruePositiveP << " = ";
    //cout << " / -1*(" << SmoothedTruePositiveS << " + " << SmoothedFalsePositiveS << " + " << SLinks << ")^2" << endl;
			if(learnRate[i][j] != 0) {
				double der = TruePositiveSDerivation[index] *(SmoothedFalsePositiveS+SLinks);
				der +=TruePositivePDerivation[index]*(SmoothedFalsePositiveP+SLinks);
				der -=FalsePositiveSDerivation[index] *  SmoothedTruePositiveS;
				der -=FalsePositivePDerivation[index] * SmoothedTruePositiveP;
				der /= -1* (SmoothedTruePositiveS+SmoothedFalsePositiveS+SLinks) * (SmoothedTruePositiveS+SmoothedFalsePositiveS+SLinks);
				//cout <<" Derivation[" << i << "]{" << j << "](" << index <<") : " << der;
				cout << " - " << ScalingFactors[i][j] << " = ";	
				der -= ScalingFactors[i][j];
				cout << der << endl;
				ScalingFactors[i][j] += learnRate[i][j] * der;
				if(j < 15)
					cout << ScalingFactors[i][j] << " ";
				//cout << "Learnrate: " << learnRate[i][j] << endl;
				//cout << "ScalingFactor: " << ScalingFactors[i][j] << endl;
			}
			index++;
		}
		cout << endl;
		FeatureSets[i]->SetScalingFactors(ScalingFactors[i]);
	}
	cout << endl,
 FalsePositivePDerivation.assign(numberOfAllFeatures,0);
 TruePositivePDerivation.assign(numberOfAllFeatures,0);
 FalsePositiveSDerivation.assign(numberOfAllFeatures,0);
 TruePositiveSDerivation.assign(numberOfAllFeatures,0);
}

