#ifndef OPTIMIZERFSCORE_H
#define OPTIMIZERFSCORE_H

#include <optimizer.h>

/**
	@author Jan Niehues <jan@niehues.info>
*/
class OptimizerFScore : public Optimizer
{
	protected:
		vector <FeatureSet *> FeatureSets;
		int TruePositiveP;
		int FalsePositiveP;
		int TruePositiveS;
		int FalsePositiveS;
		int SLinks;
		int PLinks;
		int TruePositivePCV;
		int FalsePositivePCV;
		int TruePositiveSCV;
		int FalsePositiveSCV;
		int SLinksCV;
		int PLinksCV;
		int deleteCounts;
		double SmoothedTruePositiveP;
		double SmoothedFalsePositiveP;
		double SmoothedTruePositiveS;
		double SmoothedFalsePositiveS;
		int numberOfAllFeatures;
		double alphaSigmuid;
		int iteration;
		int bestIteration;
		double bestFScore;
		vector<double> FalsePositivePDerivation;
		vector<double> TruePositivePDerivation;
		vector<double> FalsePositiveSDerivation;
		vector<double> TruePositiveSDerivation;
		vector < vector<double> > ScalingFactors;
		vector < vector<double> > bestScalingFactors;
		vector <vector<double> > learnRate;
		double alpha;
	public:
		OptimizerFScore(vector <FeatureSet *> FSets,vector < vector<double> > SFactors,char * Learnratefile,double a);
		void EvalSentence(Graph * G);
		virtual void Estimate();
		void OutputBest();
		void EvalCVSentence(Graph * G);
		void CheckScalingFactors();
		void CheckScalingFactorsWithCV();
public:
};

#endif
