#ifndef OPTIMIZERMAP_H
#define OPTIMIZERMAP_H

#include <optimizer.h>
#include <climits>
#include <cfloat>

/**
	@author Jan Niehues <jan@niehues.info>
*/
class OptimizerMAP : public Optimizer
{
	vector <FeatureSet *> FeatureSets;
	vector < vector<double> > ScalingFactors;
	vector <vector<double> > learnRate;
	vector <vector<double> > sigma;

	int bestCorrectLink;
	int bestCorrectNoLink;
	int bestFailedLink;
	int bestFailedNoLink;
	double bestLogProbCorrect;
	double bestLogProbBest;
	vector<vector<double> > bestScalingFactors;
	int bestIteration;

	int Sent;
	double logProbCorrect;
	double logProbBest;
	int CorrectLink;
	int FailedLink;
	int CorrectNoLink;
	int FailedNoLink;
	double logProbCorrectCV;
	double logProbBestCV;
	int CorrectLinkCV;
	int FailedLinkCV;
	int CorrectNoLinkCV;
	int FailedNoLinkCV;
	vector<vector<double> > EstimatedDerivations;
	int iteration;

	public:
		OptimizerMAP(vector <FeatureSet *> FSets,vector < vector<double> > SFactors,char * LearnRateFile, char * SigmaFile);

		~OptimizerMAP();
		void EvalSentence(Graph * G);
		void Estimate();
		void OutputBest();
		void EvalCVSentence(Graph * G);
		void CheckScalingFactors();
		void CheckScalingFactorsWithCV();


};

#endif
