#ifndef OPTIMIZERRECALL_H
#define OPTIMIZERRECALL_H

#include <optimizer.h>

/**
	@author Jan Niehues <jan@niehues.info>
*/
class OptimizerRecall : public Optimizer
{
 private:
  vector <FeatureSet *> FeatureSets;
  int TruePositiveP;
  int FalsePositiveP;
  int TruePositiveS;
  int FalsePositiveS;
  int SLinks;
  int PLinks;
  double SmoothedTruePositiveP;
  double SmoothedFalsePositiveP;
  double SmoothedTruePositiveS;
  double SmoothedFalsePositiveS;
  int numberOfAllFeatures;
  double alpha;
	int iteration;
	int bestIteration;
	double bestRecall;
  vector<double> FalsePositivePDerivation;
  vector<double> TruePositivePDerivation;
  vector<double> FalsePositiveSDerivation;
  vector<double> TruePositiveSDerivation;
  vector < vector<double> > ScalingFactors;
  vector < vector<double> > bestScalingFactors;
  vector <vector<double> > learnRate;
 public:
  OptimizerRecall(vector <FeatureSet *> FSets,vector < vector<double> > SFactors,char * Learnratefile);
  void EvalSentence(Graph * G);
  void Estimate();
  void OutputBest();
};

#endif
