#ifndef PARSETREE_H
#define PARSETREE_H

// Wei Chen 2008

#include <string>
#include <vector>
using namespace std;


struct TreeNode {
	string name; // the name of the node
	TreeNode *headChild; // one left-most child
	TreeNode *parent; // pointer to its parent node
	TreeNode *sister; // pointer to its right sibling
	int mark;    
};
class ParseTree;


class ParseTree {
private:
	TreeNode * root;
	void Init(TreeNode *t);
public:
	ParseTree();
	~ParseTree(){};
	void BuildTree(vector<string> tree);
	int FindDepth(int index);
	int FindMaxDepth();
	TreeNode * GetRoot();
	void ClearMark();
	void PrintTree();
};

#endif
