#ifndef PHRASEFEATURESETITERATOR_H
#define PHRASEFEATURESETITERATOR_H

#include <featuresetiterator.h>
#include <phrasefeature.h>
/**
	@author Jan Niehues <jan@niehues.info>
*/
class PhraseFeatureSetIterator : public FeatureSetIterator
{
private:
	vector<PhraseFeature *> nodes;
	vector<int> numberOfNodes;
	int nodeIndex;
	int setIndex;

public:
    PhraseFeatureSetIterator(const vector<PhraseFeature *> & nodes, const vector<int> numberOfNodes);

    ~PhraseFeatureSetIterator();
    inline bool end() const {return (setIndex == numberOfNodes.size());};
    inline void next() { nodeIndex++;while((setIndex < numberOfNodes.size())&&(nodeIndex >= numberOfNodes[setIndex])){setIndex++; nodeIndex = 0;}};
    inline Feature * feature() const {
	assert(nodeIndex < numberOfNodes[setIndex]);
	assert(setIndex < numberOfNodes.size());
		return &nodes[setIndex][nodeIndex];
    }

};

#endif
