#ifndef PHRASELOPFEATURESETITERATOR_H
#define PHRASELOPFEATURESETITERATOR_H

#include <featuresetiterator.h>
#include <phraselopfeature.h>

/**
	@author Jan Niehues <jan@niehues.info>
*/
class PhraseLOPFeatureSetIterator : public FeatureSetIterator
{
private:
	vector<PhraseLOPFeature *> nodes;
	vector<int> numberOfNodes;
	int nodeIndex;
	int setIndex;


public:
    PhraseLOPFeatureSetIterator(const vector<PhraseLOPFeature *> & nodes, const vector<int> numberOfNodes);

    ~PhraseLOPFeatureSetIterator();
    inline bool end() const {return (setIndex == numberOfNodes.size());};
    inline void next() { nodeIndex++;while((setIndex < numberOfNodes.size())&&(nodeIndex >= numberOfNodes[setIndex])){setIndex++; nodeIndex = 0;}};
    inline Feature * feature() const {
	assert(nodeIndex < numberOfNodes[setIndex]);
	assert(setIndex < numberOfNodes.size());
		return &nodes[setIndex][nodeIndex];
    }


};

#endif
