// _CharacterDBLMSentenceState.h: interface for the C_CharacterDBLMSentenceState class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX__CHARACTERDBLMSENTENCESTATE_H__1994BF1A_E9A1_4654_AC56_D2D00875BF53__INCLUDED_)
#define AFX__CHARACTERDBLMSENTENCESTATE_H__1994BF1A_E9A1_4654_AC56_D2D00875BF53__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "LMInterface.hh"
#include "_CharacterDBLM.h"
#include "_String.h"
#include "shared.h"
#include "ngramDB_shared.h"

#include <map>

using namespace std;


typedef struct s_CDBLM_State_Info{
	vector<C_String> ngram;
}S_CDBLM_State_Info;


typedef struct s_buffered_CDBLM_Info{
	int nextState;
	double logProb;
}S_Buffered_CDBLM_Info;


struct lt_CDBLM_StateInfo
{
  bool operator()(S_CDBLM_State_Info a, S_CDBLM_State_Info b) const{
	  int lenA = a.ngram.size();
	  int lenB = b.ngram.size();
		if(lenA<lenB){
			return true;
		}

		if(lenA>lenB){
			return false;
		}

		//two n-grams are of the same length		
		bool aLTb = false;
		for(int i=0;i<lenA;i++){
			if(a.ngram[i] > b.ngram[i]){
				return false;
			}

			if(a.ngram[i] < b.ngram[i]){
				return true;
			}
		}

		//a==b
		return false;
	}
};

class C_CharacterDBLMSentenceState  : public CLMSentenceState
{
public:
	CLMState BeginOfSentenceState();
	
	//! Get the logarithmic probability of a single word or phrase
	void LogProb( CLMTransition &LMTransition );
	double LogProb(CLMState lmstate, const LMWordIndex nextWordId, CLMState & nextstate);	
	virtual double LogProb( CLMState LMState, const LMWordIndex WordIndex );
	
	//! Get the logarithmic probability of sentence end.
	double LogProbEnd(CLMState lmstate);
	virtual double LogProbEnd(CLMTransition &LMTransition );

	//just need to declare these functions as used in the interface
	CLMState AppendWord( CLMState LMState, const LMWordIndex WordIndex );
	C_CharacterDBLMSentenceState(const C_CharacterDBLM * cdblm);
	virtual ~C_CharacterDBLMSentenceState();


private:
	void resetLmStates();
	void initialLmState();


	C_CharacterDBLM * cdblm;

	LMWordIndex sentEndVocId;

	vector<S_CDBLM_State_Info> allLMStates;
	map<S_CDBLM_State_Info, int, lt_CDBLM_StateInfo> lmStateInfo2Id;

	map< pair<CLMState, IndexType>, S_Buffered_CDBLM_Info> buffer;


};

#endif // !defined(AFX__CHARACTERDBLMSENTENCESTATE_H__1994BF1A_E9A1_4654_AC56_D2D00875BF53__INCLUDED_)
