#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "stdio.h"
#include "stdlib.h"
#include "_NgramDBLM.h"
#include <iostream>
#include <sstream>
#include <string>
#include "time.h"

using namespace std;

int main(int argc, char * argv[]){
	if(argc<2){
		cerr<<"\nUsage:\n\t"<<argv[0]<<" configurationFile < sentences\n";
		exit(0);
	}

	C_NgramDBLM dblm(argv[1]);

	long ltime1, ltime2, currentTime;
	time( &ltime1 );
	
	int sentScanned = 0;

	string aWord;
	char aLine[10240];
	while(!cin.eof()){
		cin.getline(aLine, 10240, '\n');

		if(strlen(aLine)>0){
			sentScanned++;

			istringstream inputLine(aLine, istringstream::in);
			CLMSentenceState * sentenceLm = dblm.NewSentence();
			CLMTransition transition;
			transition.OldState = sentenceLm->BeginOfSentenceState();

			while(! inputLine.eof()){
				inputLine>>aWord;
				LMWordIndex vocId = dblm.GetVocabularyIndex(aWord);
				transition.Words.push_back(vocId);		
			}

			sentenceLm->LogProb(transition);
			sentenceLm->LogProbEnd(transition.NewState);
			cout<<"LogProb="<<transition.Prob<<endl;
			
			delete(sentenceLm);
		}
		
		aLine[0]=0;
	}

	time( &ltime2 );	
	cerr<<"\n"<<ltime2-ltime1<<" seconds spent."<<endl;

	return 1;
}
