// _AccessNgramDB.h: interface for the C_AccessNgramDB class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX__ACCESSNGRAMDB_H__A6AD331A_5E33_4587_8453_11B40347B369__INCLUDED_)
#define AFX__ACCESSNGRAMDB_H__A6AD331A_5E33_4587_8453_11B40347B369__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "_VocabularyDB.h"
#include "_NgramFreqInfo.h"
#include "_String.h"

#include "db_cxx.h"
#include "shared.h"
#include "time.h"

#include <vector>

typedef struct s_cachedInfo{
	T_LOG_FREQ_INFO logFreq;
	long lastTimeVisited; 
}S_CachedInfo;

class C_AccessNgramDB  
{
public:
	void purgeCache(long lastTimeCalled);
	IndexType returnVocSize();
	IndexType returnId(char * text, int textLen);
	bool returnLogFreqOfNgram(vector<C_String> ngram, T_LOG_FREQ_INFO &logFreq);
	bool returnLogFreqOfNgram(vector<IndexType> ngram, T_LOG_FREQ_INFO &logFreq);
	bool returnLogFreqOfNgram(char * ngramAsCharBuffer, int bufferSize, int sizeOfn, T_LOG_FREQ_INFO &logFreq);

	C_AccessNgramDB(char * filenameStem, int maxN);
	virtual ~C_AccessNgramDB();
private:
	C_VocabularyDB * voc;
	int maxN;		//longest n-gram considered

	vector<Db *> ngramDBs;

	char buffer1[MAX_TOKEN_LEN];
	char buffer2[MAX_TOKEN_LEN];

	map< vector<IndexType>, S_CachedInfo> cache;

};

#endif // !defined(AFX__ACCESSNGRAMDB_H__A6AD331A_5E33_4587_8453_11B40347B369__INCLUDED_)
