// _NgramDBLMSentenceState.h: interface for the C_NgramDBLMSentenceState class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX__NGRAMDBLMSENTENCESTATE_H__1D9CE488_4714_4D0E_97CC_EE149985F01E__INCLUDED_)
#define AFX__NGRAMDBLMSENTENCESTATE_H__1D9CE488_4714_4D0E_97CC_EE149985F01E__INCLUDED_

//#include "LMInterface.h"
#include "LMInterface.hh"
#include "_NgramDBLM.h"
#include <vector>
#include <map>

using namespace std;


typedef struct s_DBLM_State_Info{
	vector<LMWordIndex> ngram;
}S_DBLM_State_Info;


typedef struct s_buffered_DBLM_Info{
	int nextState;
	double logProb;
}S_Buffered_DBLM_Info;


struct lt_DBLM_StateInfo
{
  bool operator()(S_DBLM_State_Info a, S_DBLM_State_Info b) const{
	  int lenA = a.ngram.size();
	  int lenB = b.ngram.size();
		if(lenA<lenB){
			return true;
		}

		if(lenA>lenB){
			return false;
		}

		//two n-grams are of the same length		
		bool aLTb = false;
		for(int i=0;i<lenA;i++){
			if(a.ngram[i]>b.ngram[i]){
				return false;
			}

			if(a.ngram[i]<b.ngram[i]){
				return true;
			}
		}

		//a==b
		return false;
	}
};


class C_NgramDBLMSentenceState : public CLMSentenceState
{
public:
	CLMState BeginOfSentenceState();
	
	//! Get the logarithmic probability of a single word or phrase
	void LogProb( CLMTransition &LMTransition );
	double LogProb(CLMState lmstate, const LMWordIndex nextWord, CLMState & nextstate);	
	virtual double LogProb( CLMState LMState, const LMWordIndex WordIndex );
	
	//! Get the logarithmic probability of sentence end.
	double LogProbEnd(CLMState lmstate);
	virtual double LogProbEnd(CLMTransition &LMTransition );

	//just need to declare these functions as used in the interface
	CLMState AppendWord( CLMState LMState, const LMWordIndex WordIndex );	

	C_NgramDBLMSentenceState(const C_NgramDBLM * dblm);
	virtual ~C_NgramDBLMSentenceState();


private:
	void resetLmStates();
	void initialLmState();


	C_NgramDBLM * dblm;

	LMWordIndex sentEndVocId;

	vector<S_DBLM_State_Info> allLMStates;
	map<S_DBLM_State_Info, int, lt_DBLM_StateInfo> lmStateInfo2Id;

	map< pair<CLMState, IndexType>, S_Buffered_DBLM_Info> buffer;
};

#endif // !defined(AFX__NGRAMDBLMSENTENCESTATE_H__1D9CE488_4714_4D0E_97CC_EE149985F01E__INCLUDED_)
