#include <memory.h>
#include "_NgramFreqInfo.h"


C_NgramFreqInfo::C_NgramFreqInfo()
{
	this->ngram.clear();
}

C_NgramFreqInfo::~C_NgramFreqInfo()
{

}


void C_NgramFreqInfo::setLogFreq(T_LOG_FREQ_INFO logFreq)
{
	this->logFreq = logFreq;
}


void C_NgramFreqInfo::addWord(IndexType wordId)
{
	this->ngram.push_back(wordId);
}


float C_NgramFreqInfo::returnLogFreq()
{
	return this->logFreq;
}

int C_NgramFreqInfo::returnNgramSize()
{
	return this->ngram.size();
}

/**
* Convert the n-gram as vocID to character buffer
* Assuming that the buffer has been allocated with memory
* and assume that there is enough space in the buffer
* we do not check if buffer exceeds its limit for better efficiency
**/
void C_NgramFreqInfo::convertNgramAsVocIdToCharBuffer(char * buffer, int & sizeOfBufferUsed)
{

	sizeOfBufferUsed = 0;
	char * bufferPointer = buffer;

	for(int i=0; i<this->ngram.size(); i++){
		IndexType wordId = this->ngram[i];
		memcpy(bufferPointer, &wordId, sizeof(IndexType));

		sizeOfBufferUsed+=sizeof(IndexType);
		bufferPointer+=sizeof(IndexType);
	}

}

void C_NgramFreqInfo::convertFreqInfoToCharBuffer(char *buffer, int &sizeOfBufferUsed)
{
	memcpy(buffer, &(this->logFreq), sizeof(T_LOG_FREQ_INFO));
	sizeOfBufferUsed = sizeof(T_LOG_FREQ_INFO);	

}

void C_NgramFreqInfo::clear()
{
	this->ngram.clear();
	this->logFreq=0;
}
