// _VocabularyDB.h: interface for the C_VocabularyDB class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX__VOCABULARYDB_H__57F46F98_2B50_492B_87F8_9D85CC8656D1__INCLUDED_)
#define AFX__VOCABULARYDB_H__57F46F98_2B50_492B_87F8_9D85CC8656D1__INCLUDED_

#include "db_cxx.h"
#include "shared.h"
#include "_String.h"
#include <map>

using namespace std;

class C_VocabularyDB  
{
public:
	IndexType returnVocSize();
	int returnText(IndexType id, char * text);
	IndexType getId(char * text, int textLen);
	IndexType returnId(char * text, int textLen);
	C_VocabularyDB(char * filename, bool readonly, bool useCache);
	virtual ~C_VocabularyDB();

private:
	bool readonly;

	/// If set to be true, then cache is turned on
	/// The effect would be that words being queried are all saved into memory
	/// Since vocabulary is usually small, loading all voc into memory would not cause
	/// too much overhead in RAM but speed up dramatically
	bool useCache;
	int readId2Text(IndexType id, char * text, int & textLen);
	int readText2Id(char * text, int textLen, IndexType &id);
	int writeText2Id(char * text, int textLen, IndexType id);
	int writeId2Text(IndexType id, char * text, int textLen);
	Db * id2text_DB;
	Db * text2id_DB;

	IndexType lastAvailabelVocId;

	char buffer[MAX_TOKEN_LEN];

	map<C_String, IndexType> cacheText2Id;
	map<IndexType, C_String> cachedId2Text;
};

#endif // !defined(AFX__VOCABULARYDB_H__57F46F98_2B50_492B_87F8_9D85CC8656D1__INCLUDED_)
