#if !defined (HEADER_N_GRAM_DB_SHARED_)

#define HEADER_N_GRAM_DB_SHARED_


//define shared data type here for n-gram DB-LM

typedef float T_FREQ_INFO;		//use float for frequency information
typedef float T_LOG_FREQ_INFO;	//use float for log-frequency

const int Size_Of_T_FREQ_INFO = sizeof(T_FREQ_INFO);

/**
* cached information for n-gram log prob
* key: n-gram history plus next word
* cached: log prob as next word given history
* and the longest matching history
**/
typedef struct s_cachedNgramLogProb{
	double logProb;
	unsigned char longestMatchingHistory;	//the longest matching length when history extended with next word
	unsigned long lastVisitedTimeStamp;
}S_CachedNgramLogProb;

#endif

