#include <DecoderBLM.hh>


long int CDecoderBLM_BP::s_NumberOfObjects = 0;


//ARV initialize the BP with the number of model scores
CDecoderBLM_BP::CDecoderBLM_BP( int numModels )
{
  //assert( 0 );

  m_TotalScore = 0.0;

  m_scaledModelScores.AssureBoundaries(0, numModels-1);
  m_scaledModelScores.SetAll(0.0);

  m_TargetLength = 0;
  m_pHyp  = NULL;
  //  m_pEdge = NULL;
  m_pBP   = NULL;

  s_NumberOfObjects++;
}



CDecoderBLM_BP::CDecoderBLM_BP( CDecoderBLM_Hyp *pHyp )
{
  //  cout << "CDecoderBLM_BP::CDecoderBLM_BP( CDecoderBLM_Hyp *pHyp )" << endl;
  m_TotalScore = pHyp->m_TotalScore;
  m_scaledModelScores = pHyp->m_scaledModelScores;
  
  //cout << "features: minindex = " << pHyp->m_scaledModelScores.MinIndex()
  //   << " maxindex = " << pHyp->m_scaledModelScores.MaxIndex() << endl;
  //for ( int i = m_scaledModelScores.MinIndex(); i <= m_scaledModelScores.MaxIndex(); i++ ) {
    //cout << i << " in pHyp " << pHyp->m_scaledModelScores[i] << " in pBP " << m_scaledModelScores[i] << endl;
  //}

  m_TargetLength = 0;
  m_pHyp  = pHyp;
  //m_pEdge = pHyp->m_pEdge;
  m_pBP   = NULL;

  s_NumberOfObjects++;
}




CDecoderBLM_BP::CDecoderBLM_BP( CDecoderBLM_BP *pBP )
{
  m_TotalScore = pBP->m_TotalScore;
  m_scaledModelScores = pBP->m_scaledModelScores;

  m_TargetLength = pBP->m_TargetLength;
  m_pHyp       = pBP->m_pHyp;
  //m_pEdge      = pBP->m_pEdge;
  m_pBP        = pBP;

  s_NumberOfObjects++;
}




CDecoderBLM_BP::~CDecoderBLM_BP()
{
  s_NumberOfObjects--;
}


