#include <DecoderBLM.hh>


//bool CDecoderBLM_Hyp::s_UseCoverage = true;
//bool CDecoderBLM_Hyp::s_UseCoveragePattern = true;
//bool CDecoderBLM_Hyp::s_UseLMState = true;
//bool CDecoderBLM_Hyp::s_UseTargetLength = true;

//bool CDecoderBLM_Hyp::s_UseCoverageForPruning = true;
//bool CDecoderBLM_Hyp::s_UseCoveragePatternForPruning = true;
//bool CDecoderBLM_Hyp::s_UseLMStateForPruning = true;
//bool CDecoderBLM_Hyp::s_UseTargetLengthForPruning = false;

//short CDecoderBLM_Hyp::s_MaxNumReorderings = 77;


long int CDecoderBLM_Hyp::s_NumberOfObjects = 0;
bool     CDecoderBLM_Hyp::s_TraceOn = false;



ostream &
operator <<( ostream& Stream, const CDecoderBLM_Hyp &Hyp )
{
  Stream
    << "\nTotal Score " << Hyp.m_TotalScore;

    //	 << "\nACScore       " << hyp.m_ACScore 
    /*
    << "  LMScore " << Hyp.m_scaledModelScores[ c_LM1 ]
    << "  ALScore " << Hyp.m_scaledModelScores[ c_AL1 ]
    << "  WCScore " << Hyp.m_scaledModelScores[ c_SL1 ]
    << "  PCScore " << Hyp.m_scaledModelScores[ c_PL1 ];

  for ( int index = c_TM1; index <= Hyp.m_scaledModelScores.MaxIndex(); index++ ) {
    Stream << " TMScore-" << index << " " << Hyp.m_scaledModelScores[ index ];
  }
    */

  for ( int index = Hyp.m_scaledModelScores.MinIndex(); index <= Hyp.m_scaledModelScores.MaxIndex(); index++ ) {
    Stream << " ModelScore-" << index << " " << Hyp.m_scaledModelScores[ index ];
  }

  Stream 
    << "\nCoverage " << Hyp.m_Coverage << " " << Hyp.m_CoverageStart << " " << Hyp.m_CoveragePattern 
    << "  LMState " << Hyp.m_LMStates[ Hyp.m_LMStates.MinIndex() ] 
    << "  Target Length " << Hyp.m_TargetLength 
    << "\nEdge " << Hyp.m_pEdge 
    << "  Previous Hyp " << Hyp.m_pPrevHyp;
	//	 << "\nNumber Hyps   " << hyp.s_NumberOfObjects;

  return Stream;
  
}



CDecoderBLM_Hyp::CDecoderBLM_Hyp()
{
  Trace( 3, "CDecoderBLM_Hyp Constructor" );
  //m_LMState = 0;
  m_TotalScore = 0.0;
  m_Coverage = 0;
  m_CoverageStart = 0;
  m_CoveragePattern = 0;
  m_NumReorderings = 0;
  m_TargetLength = 0;
  m_Expand = true;
  m_pDecoderInfo = NULL;
  m_pEdge = NULL;
  m_pPrevHyp = NULL;
  m_pRecombinedHyps = NULL;
  s_NumberOfObjects++;
}



CDecoderBLM_Hyp::CDecoderBLM_Hyp( int numModels )
{
  Trace( 3, "CDecoderBLM_Hyp Constructor" );
  //m_LMState = 0;
  
  m_scaledModelScores.AssureBoundaries( 0, numModels - 1 );
  m_scaledModelScores.SetAll( 0.0 );

  m_TotalScore = 0.0;
  m_Coverage = 0;
  m_CoverageStart = 0;
  m_CoveragePattern = 0;
  m_NumReorderings = 0;
  m_TargetLength = 0;
  m_Expand = true;
  m_pDecoderInfo = NULL;
  m_pEdge = NULL;
  m_pPrevHyp = NULL;
  m_pRecombinedHyps = NULL;
  s_NumberOfObjects++;
}



CDecoderBLM_Hyp::CDecoderBLM_Hyp( const CDecoderBLM_Hyp &Hyp )
{
  Trace( 3, "CDecoderBLM_Hyp Copy Constructor" );
  m_LMStates = Hyp.m_LMStates;

  m_scaledModelScores = Hyp.m_scaledModelScores;

  m_TotalScore = Hyp.m_TotalScore;
  m_Coverage = Hyp.m_Coverage;
  m_CoverageStart = Hyp.m_CoverageStart;
  m_CoveragePattern = Hyp.m_CoveragePattern;
  m_NumReorderings = Hyp.m_NumReorderings;
  m_TargetLength = Hyp.m_TargetLength;
  m_Expand = Hyp.m_Expand;
  m_pDecoderInfo = Hyp.m_pDecoderInfo;
  m_pEdge = Hyp.m_pEdge;
  m_pPrevHyp = Hyp.m_pPrevHyp;
  m_pRecombinedHyps = m_pRecombinedHyps;
  s_NumberOfObjects++;
}



CDecoderBLM_Hyp::~CDecoderBLM_Hyp()
{
  // delete recombined Hyps
  //multimap< float, CDecoderBLM_Hyp * > *m_pRecombinedHyps;
  multimap< float, CDecoderBLM_Hyp * >::iterator Iter;
  CDecoderBLM_Hyp *pHyp;

  //cout<<"m_pRecombinedHyps:"<<m_pRecombinedHyps<<endl;
  if ( m_pRecombinedHyps != NULL) {
    //cout<<"deleting:"<<m_pRecombinedHyps<<endl;
    // error generation
    // ARV
    // added a check in here m_pRecombinedHyps != NULL    
    for ( Iter = m_pRecombinedHyps->begin();  Iter != m_pRecombinedHyps->end(); ++Iter ) {
      //pHyp = Iter->second;
      //m_pRecombinedHyps->erase( Iter );
        
      //cout<<"InnerHyp:"<<Iter->second<<endl;
      if (Iter->second!=NULL){
        //cout<<"InnerNOTNULL:"<<Iter->second<<endl;
        delete Iter->second;
	    
      }
	  
    }
    // ARV
    // screen to take care of a recombination that was deleted further down
    if (m_pRecombinedHyps != NULL){
      // changed this to delete the map object that stores the recombined hypothesese
      m_pRecombinedHyps->clear();
	  //delete m_pRecombinedHyps;
      m_pRecombinedHyps = NULL;
    }
  }else{
    //ARV
    // it is already removed
  }

  s_NumberOfObjects--;
}



CDecoderBLM_Hyp &
CDecoderBLM_Hyp::operator = ( const CDecoderBLM_Hyp &Hyp )
{
  if ( this == &Hyp ) 
    //-- Kopie auf sich selber kann ignoriert werden
    return *this;

  m_LMStates = Hyp.m_LMStates;

  m_scaledModelScores = Hyp.m_scaledModelScores;

  m_TotalScore = Hyp.m_TotalScore;
  m_Coverage = Hyp.m_Coverage;
  m_CoverageStart = Hyp.m_CoverageStart;
  m_CoveragePattern = Hyp.m_CoveragePattern;
  m_NumReorderings = Hyp.m_NumReorderings;
  m_TargetLength = Hyp.m_TargetLength;
  m_Expand = Hyp.m_Expand;
  m_pDecoderInfo = Hyp.m_pDecoderInfo;
  m_pEdge = Hyp.m_pEdge;
  m_pPrevHyp = Hyp.m_pPrevHyp;
  m_pRecombinedHyps = Hyp.m_pRecombinedHyps;

  return *this;
}



bool
CDecoderBLM_Hyp::TestAndSetCoverage( int j_min, int j_max )
{
  bool TraceOn = s_TraceOn;
  s_TraceOn = false;

  TraceIf( s_TraceOn, 0, "CDecoderBLM_Hyp::TestAndSetCoverage " << j_min << " " << j_max );

  // the parameters are interpreted as the positions between the words
  // i.e. as node numbers in a lattice
  // 2 3 means therefore: test coverage of word running from 
  // node 2 to 3
  // the coverage signature itself is in terms of positions of the words
  // i.e. 2 to 3 is word position 2

  // return value: true if all positions free, false if collision


  TraceIf( s_TraceOn, 0, m_CoverageStart << " " << m_CoveragePattern );

  // test that first position is free, as otherwise the shifting of
  // the coverage pattern failed in the previous step
  assert( !m_CoveragePattern[ 0 ] );

  // make sure expansion is not moving outside of maximally allowed region
  // otherwise we can not store the coverage pattern
  // ToDo: should allow for long expansion without gap
  if ( j_max - m_CoverageStart > c_MaxReorderWindowLength ) {
    //TraceIf( true, 0, "j_max - m_CoverageStart <= c_MaxReorderWindowLength" ); apd 1/28/07
    //assert( j_max - m_CoverageStart <= c_MaxReorderWindowLength );
    return false;
  }
  

  // make sure we are starting beyond what has already been completely covered
  if ( j_min < m_CoverageStart ) {
    TraceIf( true, 0, "j_min = " << j_min << " < m_CoverageStart = " << m_CoverageStart );
    assert( j_min >= m_CoverageStart );
    return false;
  }

  // first we check if there is a collision
  // at the same time we set the requested positions
  for ( int j = j_min; j < j_max; j++ ) {
    if ( m_CoveragePattern[ j - m_CoverageStart ] ) {
      TraceIf( s_TraceOn, 0, "Collision at position " << j );
      return false;
    } else {
      TraceIf( s_TraceOn, 0, "set bit at position " << j );
      m_CoveragePattern[ j - m_CoverageStart ] = true;
      TraceIf( s_TraceOn, 0, m_CoveragePattern );
      m_Coverage++;
    }
  }

  // now we check if the lowest bits are set
  // if yes, shift the pattern and increment CoverageStart
  while ( m_CoveragePattern[ 0 ] ) {
    TraceIf( s_TraceOn, 0, "shift start of coverage pattern" );
    m_CoveragePattern >>= 1;
    m_CoverageStart++;
    TraceIf( s_TraceOn, 0, m_CoverageStart << " " << m_CoveragePattern );
  }

  assert( !m_CoveragePattern[ 0 ] );

  s_TraceOn = false;

  return true;
}


