#ifndef __NBestListRescorer__
#define __NBestListRescorer__


//#include "Trace.hh"
//#include <Bool.hh>

#include <Text.hh>
#include <Lexicon.hh>
#include <AlignProbRel.hh>

//#include <LMInterface.hh>
//#include <LMwordSA.hh>





class CNBestListRescorer
{
public:
  CNBestListRescorer();
  virtual ~CNBestListRescorer();

  bool Init();

  virtual double Prob( const CSentence &SourceSentence,
                       const CSentence &TargetSentence );

  virtual double LogProb( const CSentence &SourceSentence,
                          const CSentence &TargetSentence );

  double NegLogProb( const CSentence &SourceSentence,
                             const CSentence &TargetSentence );


};



class CNBestListRescorerTM : public CNBestListRescorer
{
public:
  CNBestListRescorerTM();
  virtual ~CNBestListRescorerTM();
  
  bool Init( CLexicon *pLexicon );

//  virtual double Prob   ( const CSentence &SourceSentence,
//                          const CSentence &TargetSentence );

//  virtual double LogProb( const CSentence &SourceSentence,
//                          const CSentence &TargetSentence );


protected:
  CLexicon *m_pLexicon;

};



class CNBestListRescorerTM_IBM1 : public CNBestListRescorerTM
{
public:
  CNBestListRescorerTM_IBM1();
  virtual ~CNBestListRescorerTM_IBM1();

  //bool Init( CLexicon *pLexicon );

  virtual double Prob( const CSentence &SourceSentence,
                       const CSentence &TargetSentence );

  virtual double LogProb( const CSentence &SourceSentence,
                          const CSentence &TargetSentence );


protected:
  // in baseclass: CLexicon *m_pLexicon;

};


class CNBestListRescorerTM_HMM : public CNBestListRescorerTM
{
public:
  CNBestListRescorerTM_HMM();
  virtual ~CNBestListRescorerTM_HMM();

  bool Init( CLexicon *pLexicon, CAlignProbRel *pAlignProb );

  virtual double Prob( const CSentence &SourceSentence,
                       const CSentence &TargetSentence );

  virtual double LogProb( const CSentence &SourceSentence,
                          const CSentence &TargetSentence );


protected:

  double
  AlignLogPr( int i, int iprev );


  // in baseclass: CLexicon *m_pLexicon;
  CAlignProbRel *m_pAlignProb;
};



#endif
