#define NO_TRACE 1
#include <Trace.hh>

#include <NBestListRescorerLM.hh>


// ---------------------------------------
// CNBestListRescorerLM
// ---------------------------------------

CNBestListRescorerLM::CNBestListRescorerLM( )
{
}

CNBestListRescorerLM::~CNBestListRescorerLM( )
{
}


bool
CNBestListRescorerLM::Init( CLM *pLM, CVocabulary* pVocabulary )
{
  m_pLM = pLM;
  m_pVocabulary = pVocabulary;
}


double 
CNBestListRescorerLM::Prob( const CSentence &Sentence )
{
  return exp( LogProb( Sentence ) );
}


double 
CNBestListRescorerLM::NegLogProb( const CSentence &Sentence )
{
  return -LogProb( Sentence );
}



double 
CNBestListRescorerLM::LogProb( const CSentence &Sentence )
{

  Trace( 1, "CNBestListRescorerLM::LogProb()" );
  //Sentence.Display( m_pVocabulary );
  //std::cout << std::endl;

  CLMSentenceState *pLMSentenceState;
  CLMState LMState;
  CLMState NewLMState;
  double LMScore = 0.0;

  if ( m_pLM ) {
    pLMSentenceState = m_pLM->NewSentence();
    LMState = pLMSentenceState->BeginOfSentenceState();
    //cerr << "LMState for begin of sentence is " << LMState <<endl;
  }

  double LogP = 0.0;
  double SumP = 0.0;
  CWordIndex WordIndex;
  
  // Go over all words in the source sentence 
  for( int j = Sentence.MinIndex(); j <= Sentence.MaxIndex(); j++ ){

    CWordIndex w = Sentence[ j ];
    CString Word = m_pVocabulary->GetWord( w );
    LMWordIndex WordIndex = m_pLM->GetVocabularyIndex( (string)((const char *)( Word )) );
    LMScore += pLMSentenceState->LogProb( LMState, WordIndex );
    //cerr << "LM-Score for " << WordIndex << ": " 
    //        << pLMSentenceState->LogProb( LMState, WordIndex ) 
    //        << " total LM-Score = " << LMScore << endl;

    NewLMState = pLMSentenceState->AppendWord( LMState, WordIndex );
    Trace( 3, "Version 2: New LM-State: " << NewLMState );
    LMState = NewLMState;
  }

  //cerr << "LM LogProb = " << LMScore << endl;

  return LMScore;

}

