#ifndef __LatticeRescorer__
#define __LatticeDescorer__


//#include "Trace.hh"
//#include <Bool.hh>

#include <Lexicon.hh>

//#include <Lattice.hh>
#include <LatticeEdgeTrans.hh>
#include <LatticeLM.hh>

//#include <LMInterface.hh>
//#include <LMwordSA.hh>


// the score for a word not translated
//const float c_TMScoreForSourceWord = 10.0;


class CLatticeRescorer
{
public:
  //  CLatticeRescorer();
  // ~CLatticeRescorer();
  
  // rescore lattice with lexical probabilities
  void Rescore( CLatticeLM *pLattice, CLexicon *pLexicon );

  // rescore lattice with (1-Lambda) p(f|e) + Lambda p(e|f)
  void Rescore( CLatticeLM *pLattice, CLexicon *pLexicon, CLexicon *pReverseLexicon, float Lambda );

  // Boost longer translations: PrBoost = Pr^(1/(1+b(I-1))) I is target
  // length, b is boost factor which is: ScoreBoost = - LogPrBoost = -
  // 1/(1+b(I-1))* LogPr = 1/(1+b(I-1)) * Score 
  // b = 0 -> no boost, b = 1 -> Pr of phrase equal average Pr per word
  void SetBoostFactor( float BoostFactor );

protected:
  double CalcLogProb( const CSentence &S1, const CSentence &S2, const CLexicon *pLexicon );

  float m_BoostFactor;
};


#endif
