//Nguyen, July 15, 2008: 
//Dependency Tree tokens
//
#ifndef TOKENS_HH_
#define TOKENS_HH_

//dependency tokens struture
#include <iostream>
#include <string>
#include <vector>
#include <sstream>
#include <fstream>
#include <iomanip>
#include <queue>

struct tokens{
	std::string name;  // token value
	int post;          // token position	
	int parentpost;    // parent postion
	std::string dtype; // dependency type
	std::string pos;   // toke's POS tag
};


//return tokes value
std::string getName(const tokens& ); 

//return position of the token in string
int getPost(const tokens& ); 

//return parent's position of the token in string
int getParentPost(const tokens& ); 

//return dependency type
std::string getDType(const tokens& ); 

//return token POS tag
std::string getPOS(const tokens& ); 

//string to int
int str2int (const std::string&);

//int 2 string
std::string int2str (int ); 

//return string of vector
std::string getNameFromVector (const std::vector<tokens>& );

//return Positions of vector
std::string getPostFromVector (const std::vector<tokens>& );


// split line by space charactes; space = " ", "\t", ...
std::vector<std::string> split(const std::string& );

//read CoNLL dependency data from file into a 2D vector of tokens
void readCoNLLformat( const char* , std::vector < std::vector<tokens> >& );

// return FALSE/0 if n is not a node of tree T
//        TRUE/1 otherwise
bool insubtree( const tokens& , const tokens& , const std::vector<tokens>& );

#endif /*TOKENS_HH_*/
