// _DiscriminativeLM.h: interface for the C_DiscriminativeLM class.
//
//
// $Rev: 3925 $
// $LastChangedData$
//
//////////////////////////////////////////////////////////////////////

#if !defined(__HEADER_DISCRIMINATIVE_LM__)
#define __HEADER_DISCRIMINATIVE_LM__

#include "LMInterface.hh"
#include "_IDVocabulary.h"
#include "_Ngram.h"

#include <map>
#include <vector>

using namespace std;

class C_DiscriminativeLM : public CLM  
{
public:
	int returnMaxN();
	C_DiscriminativeLM(const char * cfgFileName);
	virtual ~C_DiscriminativeLM();

	virtual LMWordIndex VocabularySize() const;
	virtual LMWordIndex returnSentStartVocId();
	virtual LMWordIndex returnSentEndVocId();

	bool returnCost(C_Ngram & ngram, float & cost);

	virtual LMWordIndex GetVocabularyIndex(string word);
	virtual const vector< string > & Vocabulary() const;

	CLMSentenceState * NewSentence() const;

protected:
 	C_IDVocabulary * idVoc;
  
private:	
	void loadNgramDiscrCost(char * filename);
	
	LMWordIndex sentStartVocId;
	LMWordIndex sentEndVocId;

	map<C_Ngram, float> ngramCost;

	int maxN;

};

#endif // !defined(__HEADER_DISCRIMINATIVE_LM__)
