// _DiscriminativeLMSentenceState.h: interface for the C_DiscriminativeLMSentenceState class.
//
//
// $Rev: 3922 $
// $LastChangedData$
//
//////////////////////////////////////////////////////////////////////

#if !defined(__HEADER_DISCRIMINATIVE_LM_SENTENCE_STATE__)
#define __HEADER_DISCRIMINATIVE_LM_SENTENCE_STATE__

#include "LMInterface.hh"
#include "_DiscriminativeLM.h"
#include "_Ngram.h"

typedef struct s_bufferedDiscrimLmInfo{
	int nextState;
	float cost;
}S_BufferedDiscrimLmInfo;

class C_DiscriminativeLMSentenceState : public CLMSentenceState  
{
public:
	C_DiscriminativeLMSentenceState(const C_DiscriminativeLM * discrimLm);
	virtual ~C_DiscriminativeLMSentenceState();

	CLMState BeginOfSentenceState();
	
	//! Get the logarithmic probability of a single word or phrase
	void LogProb( CLMTransition &LMTransition );
	double LogProb(CLMState lmstate, const LMWordIndex nextWord, CLMState & nextstate);	
	virtual double LogProb( CLMState LMState, const LMWordIndex WordIndex );
	
	//! Get the logarithmic probability of sentence end.
	double LogProbEnd(CLMState lmstate);
	virtual double LogProbEnd(CLMTransition &LMTransition );

	//just need to declare these functions as used in the interface
	CLMState AppendWord( CLMState LMState, const LMWordIndex WordIndex );	

private:
	void resetLmStates();
	void initialLmState();	

	map< pair<CLMState, IndexType>, S_BufferedDiscrimLmInfo> buffer;
	map<C_Ngram, int> lmStateInfo2Id;
	vector<C_Ngram> allLMStates;
	
	C_DiscriminativeLM * discrimLm;
	
	int maxN;

	LMWordIndex sentStartVocId;
	LMWordIndex sentEndVocId;


};

#endif // !defined(__HEADER_DISCRIMINATIVE_LM_SENTENCE_STATE__)
