/*
 *  EvaluatorCER.h
 *  STTK_Lattice_Evaluator_SVN
 *
 *  Created by Anton D'Auria on 10/26/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */


#ifndef __EvaluatorCER__
#define __EvaluatorCER__

#include <EvaluatorWER.hh>
#include <TextFilterBoostRegex.hh>

//====================================================================
//      CEvaluatorCER
//

class CEvaluatorCER : public CEvaluatorWER
{
  
public:
  CEvaluatorCER( CVocabulary *pVocabulary, CEvaluatorSharedData *pSharedData );
  ~CEvaluatorCER();
  
  // checks if references were converted                                                                                                                                                                                                                                                                
  // converts passed Csentence
  bool Evaluate( int sourceSentenceIndex, CSentence* pHypSentence, 
                 CNumericalArray< float >& Scores);
 
  bool Evaluate( CSentence* pHypSentence, CArray< CSentence* > &References,
                CNumericalArray< float >& Scores );
protected:
  
  void ReportScores( CNumericalArray< float >& Scores );
  
  //! retrieve refs from pSharedData, delete existing altered ref, create new
  void TokenizeReferences( CArray< CArray< CSentence* > >* pRefSentences );
  
  //! creates a copy of pSentence in which every character is tokenized
  CSentence* TokenizeSentence( CSentence* pSentence );

  //! deletes altered reference sentences and clears container
  void ResetAlteredReferences();
  
private:
    
  CArray< CArray< CSentence* > >* m_pAlteredRefSentences;
  
  //! to check against ref changes to see if m_pAlteredRefSentences should be called
  CArray< CArray< CSentence* > >* m_pOrigRefSentences;
  
}; 

#endif
