/*
 *  EvaluatorNistBLEU.hh
 *  STTK_Anthony2
 *
 *  Created by Anton D'Auria on 7/23/06.
 *  
 *  Nist's "implementation" of IBM BLEU, with one small change
 *   Length penalty is computed with shortest reference sentence length,
 *   not closest ref sentence length.
 *
 */

#ifndef __EvaluatorNistBLEU__
#define __EvaluatorNistBLEU__

#include "EvaluatorBLEU.hh"

//====================================================================
//      CEvaluatorNistBLEU
//

class CEvaluatorNistBLEU : public CEvaluatorBLEU
{
public: 
  CEvaluatorNistBLEU( CVocabulary *pVocabulary, CEvaluatorSharedData *pSharedData);
  ~CEvaluatorNistBLEU();
  
  
  //! builds [source][hyp] arr of CEvaluatorNGramStats that contain values 
  //! needed for Nist-Bleu scoring of each source/hyp pair, and saves to m_p_hypMatchStats
  virtual bool ComputeNGramMatchStats( CArray< CArray< CSentence* > >* pNBestTranslations);

  
  //! Print scores to screen
  virtual void ReportScores( CNumericalArray< float > & Scores );

};



#endif
