#include <config.h>
//#include <fortify.h>
// CTM-IBM1: Translation Model IBM1, Mixture Densities without alignments

#ifndef __tm_Graph_IBM1__
#define __tm_Graph_IBM1__

#include <TM_IBM1.hh>
#include <TransMem.hh>




class CTM_Graph_IBM1 : public CTM_IBM1
{
public:
  CTM_Graph_IBM1();
  ~CTM_Graph_IBM1();

  void SetTransMemParamFiles( CString ParamFileF, CString ParamFileE );

  bool Train();
  double Perplexity();

  static CLatticeLM * ConvertToLattice( const CSentence *pSentence, 
					const CVocabulary *pVoc );

  double SentenceLogProb( const CSentence *pSentenceF, const CSentence *pSentenceE );
double PhraseTranslationLogProb( const CSentence *pSentenceF, const CSentence *pSentenceE );

protected:
  bool NextIteration();
  void SegmentSentences();
  CWordIndex GetWordIndexE( CLatticeEdgeTrans *pEdgeE );
  CWordIndex GetWordIndexF( CLatticeEdgeTrans *pEdgeF );

  double Probability( CLatticeEdgeTrans *pEdgeF, CLatticeEdgeTrans *pEdgeE );

protected:
  CString m_TransMemParamFileE;
  CString m_TransMemParamFileF;

  CTranslationMemory *m_pTransMemF;
  CTranslationMemory *m_pTransMemE;
  
  static CLatticeEdgeTrans *m_pLatticeEdgeTrans;

};

#endif


