#if !defined (SHARED_HEADER_FILE)
#define SHARED_HEADER_FILE

//typedef unsigned long IndexType;
typedef unsigned int IndexType;      //better check the range under different OS/platform
//under typical linux machines, the range is 4,294,967,296(4G)

//typedef unsigned long TextLenType;
typedef unsigned int TextLenType;    //better check the range for different OS/platform

typedef unsigned short int SearchLenType;//e.g. search n-gram for how long
typedef double WordPairValueType;

const unsigned int MAX_TOKEN_LEN = 1024;
const unsigned int MAX_VALID_TOKEN_LEN = 30;
const unsigned int MAX_SENT_SIZE = 4096;

const double NORMALIZED_BIG_N_CONST	 = 100000.0;

const double SMALL_FLOAT_VALUE =  1e-10;
const double SMALL_DOUBLE_VALUE = 1e-10;

const unsigned int NULL_TGT_WORD_POSITION = (unsigned int) -100;
const unsigned int NULL_SRC_WORD_POSITION = (unsigned int) -100;

const unsigned short NULL_TGT_WORD_POSITION_SHORT = (unsigned short) -100;
const unsigned short NULL_SRC_WORD_POSITION_SHORT = (unsigned short) -100;

//constant used in infoNet
const unsigned int INFO_NET_MAX_NUMBER_ITEMS_EACH_SAMPLE = 10000;	//to speed up sample, at most this number of items to be sampled
const double INFO_NET_SAMPLE_RATE = 0.01;
const unsigned int INFO_NET_SAMPLE_TIMES = 10;

//typedef for parsing tree
typedef unsigned short NodeIdInParsingTreeType;		//each tree can have at most 65536 nodes

#endif
