#include <config.h>

#include <suffixsort.hh>


suffixsort::suffixsort(vector<LMWordIndex>*c, LMSuffix p, LMWordIndex eoline) {
  corpus=c; posinc=p;
  cc=corpus->size(); EOLine=eoline;
}

suffixsort::~suffixsort() {}

void
suffixsort::setdist(LMSuffix p) { posinc=p; }

bool
suffixsort::operator()(LMWordIndex b, LMSuffix a) {
  a+=posinc;
  if(a >= cc /*|| (*corpus)[a] == EOLine*/)
    return true;
  else
    return ((*corpus)[a] > b);
}

bool
suffixsort::operator()( LMSuffix a, LMWordIndex b) {
  a+=posinc;
  if(a >= cc /*|| (*corpus)[a] == EOLine*/)
    return false;
  else
    return ((*corpus)[a] < b);
}

bool
suffixsort::operator()( LMSuffix aa, LMSuffix bb) {
  if(aa==bb) return false;
  aa = (aa+posinc) % cc; bb = (bb+posinc) % cc;

  while((*corpus)[aa] == (*corpus)[bb]
     /*&& (*corpus)[aa] != EOLine
     && (*corpus)[bb] != EOLine*/)
  {
    if (++aa == cc) aa = 0;
    if (++bb == cc) bb = 0;
  }
  return ((*corpus)[aa]<(*corpus)[bb]);
}
