#include <config.h>

#include <String.hh>


//typedef unsigned short int TEdgeID;
//typedef unsigned short int TNodeID;
inline
CLatticeEdge::CLatticeEdge()
{
  m_pFromNode = NULL;
  m_pToNode = NULL;
  s_NumberOfObjects++;
}



inline
CLatticeEdge::CLatticeEdge( const CLatticeEdge &Edge )
{
  CopyFrom( &Edge );
  s_NumberOfObjects++;
}



inline
CLatticeEdge::CLatticeEdge( CLatticeNode *f, CLatticeNode *t )
{
  m_pFromNode = f;
  m_pToNode = t;
  s_NumberOfObjects++;
}



inline
CLatticeEdge::CLatticeEdge( CLatticeNode *f, CLatticeNode *t, char * /* c */ )
//:m_Word(c)
{
  m_pFromNode = f;
  m_pToNode = t;
  s_NumberOfObjects++;
}



inline
CLatticeEdge::~CLatticeEdge()
{
  s_NumberOfObjects--;
}



inline void
CLatticeEdge::CopyFrom( const CLatticeEdge *pEdge )
{
  this->m_pFromNode = pEdge->m_pFromNode;
  this->m_pToNode   = pEdge->m_pToNode;
}



inline void
CLatticeEdge::CopyTo( CLatticeEdge *pEdge ) const
{
  pEdge->m_pFromNode = this->m_pFromNode;
  pEdge->m_pToNode   = this->m_pToNode;
}



inline CLatticeEdge *
CLatticeEdge::Clone() const
{
  //  Trace( 1, "CLatticeEdge::Clone()" );
  CLatticeEdge *pNewEdge = new CLatticeEdge;
  *pNewEdge = *this;
  return pNewEdge;
}

//inline CLatticeEdge * 
//Concatenate( const CLatticeEdge * )
//{
//  return NULL;
//}



inline void
CLatticeEdge::Init( CLatticeNode *f, CLatticeNode *t, const char * /* c */ )
{
  m_pFromNode = f;
  m_pToNode = t;
}



// Selektor fr Startknoten
inline CLatticeNode *
CLatticeEdge::FromNode()
{
  return m_pFromNode;
}



// Selektor fr Zielknoten
inline CLatticeNode *
CLatticeEdge::ToNode()
{
  return m_pToNode;
}



// Selektor fr berspanntes Wort
// inline const CString &
// CLatticeEdge::Word() 
// {
//   return m_Word;
// }


inline float
CLatticeEdge::Score() const
{
  cerr << "++++++++WRONG SCORE()+++++++++" << endl;

  return 0.1;
}



inline void
CLatticeEdge::SetScore( float Score )
{
  //do nothing; subclass's SetScore should be called
  
  cerr << "++++++++WRONG SETSCORE()+++++++++" << endl;
}



inline bool
CLatticeEdge::ShouldBeRemoved() const
{
  return false;
}



// einstelliger Ausgabeoperator
inline ostream& 
CLatticeEdge::operator<<( ostream& os )
{
  int FromNodeNumber, ToNodeNumber;

  if (m_pFromNode)
    FromNodeNumber = m_pFromNode->Number();
  else
    FromNodeNumber = -1;

  if (m_pToNode)
    ToNodeNumber = m_pToNode->Number();
  else
    ToNodeNumber = -1;

  /*
  return (os << "edge " //<< this 
	  // << " (" << m_FromNode << '-' << m_ToNode << " | " 
	  << "(" << FromNodeNumber << "-" << ToNodeNumber
	  << ") \"" << m_Word << '\"') << endl;
  */
  return (os << "edge " 
	  << "(" << FromNodeNumber << "-" << ToNodeNumber << ")"<< endl );
}



inline void
CLatticeEdge::WriteTo( ostream& os)
{
   int FromNodeNumber, ToNodeNumber;

  if (m_pFromNode)
    FromNodeNumber = m_pFromNode->Number();
  else
    FromNodeNumber = -1;

  if (m_pToNode)
    ToNodeNumber = m_pToNode->Number();
  else
    ToNodeNumber = -1;
  
  os << FromNodeNumber << "\t" << ToNodeNumber << "\t";

}


// Zweistelliger Ausgabeoperator fr Lattice-Knoten.
//  @param os Ausgabestrom
//  @param n  Referenz auf auszugebenden Knoten 
//  template< class TNode >
//  inline ostream& 
//  operator<<(ostream& os, TEdge& e)
//  {
//    return e.operator<<(os);
//  }


inline bool
CLatticeEdge::operator==( CLatticeEdge &Edge )
{ 
  //  Trace( 1, "CLatticeEdge::operator==" );
  return ( ( FromNode() == Edge.FromNode() ) 
	&&  ( ToNode() == Edge.ToNode() ) );
}

inline bool
CLatticeEdge::operator<( CLatticeEdge & )
{
  return false;
}

