// include configure results
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// enable/disable tracing for this module here
#define NO_TRACE 1
//#undef NO_TRACE
#include <Trace.hh>

#include <Lattice.hh>

// remove outgoing edge
void
CLatticeNode::RemoveOutEdge( CLatticeEdge *pOutEdge )
{
  Trace( 2, "CLatticeNode::RemoveOutEdge" );
  Trace( 2, this << " " << m_OutEdges.MinIndex() << " " << m_OutEdges.MaxIndex() );

  for ( int o = m_OutEdges.MinIndex(); o <= m_OutEdges.MaxIndex(); o++ ) {
    Trace( 2, o << " " << m_OutEdges[ o ] << " " <<  pOutEdge );
    if ( m_OutEdges[ o ] == pOutEdge ) {
      Trace( 2, "Edge found - remove it now" );
      m_OutEdges.Remove( o );
    }
  }
  Trace( 2, m_OutEdges.MinIndex() << " " << m_OutEdges.MaxIndex() );
}


// remove ingoing edge
void
CLatticeNode::RemoveInEdge( CLatticeEdge * pInEdge )
{
  Trace( 2, "CLatticeNode::RemoveInEdge" );
  Trace( 2, this << " " << m_InEdges.MinIndex() << " " << m_InEdges.MaxIndex() );

  for ( int i = m_InEdges.MinIndex(); i <= m_InEdges.MaxIndex(); i++ ) {
    if ( m_InEdges[ i ] == pInEdge ) {
      m_InEdges.Remove( i );
    }
  }
  Trace( 2, m_InEdges.MinIndex() << " " << m_InEdges.MaxIndex() );
}


