#ifndef __PHRASE_ALIGN_MS_TAB__
#define __PHRASE_ALIGN_MS_TAB__

// find optimal target phrase for given source phrase in 
// a sentence pair
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <SortedArray.hh>
#include <Text.hh>
#include <Lexicon.hh>
#include <Trace.hh>
#include <PhraseAlignMS.hh>
#include <PhraseAlignProbCalc.hh>
#include <MapWordToTag.hh>
#include <fortify.h>
#define DEBUG 1


class CPhraseAlignerMSTag:public CPhraseAlignerMS
{
public:
  CPhraseAlignerMSTag();
  virtual ~CPhraseAlignerMSTag();

  //Init the PhraseAligner
  void Init(CLexicon *pLexiconSourceTarget,CLexicon *pLexiconTargetSource,CPhraseAlignProbCalc *calc,
	    CMapWordToTag *pMappingSource, CMapWordToTag *pMappingTarget,
	    CLexicon *pTagLexiconSourceTarget,CLexicon *pTagLexiconTargetSource);



  bool AlignPhrase( CSentence *pSourceSentence, CSentence *pTargetSentence,
		    int StartSource, int EndSource,
		    CSortedArray< CPhraseAlignItemMS > & PhraseAlignItems );



protected:

  //Word->Tag Mapping
  CMapWordToTag *m_pMappingSource;
  CMapWordToTag *m_pMappingTarget;

  // the tag sentences
  CSentence *m_pSourceTagSentence;
  CSentence *m_pTargetTagSentence;


  // the lexica of the Tags
  CLexicon *m_pTagLexiconSourceTarget;
  CLexicon *m_pTagLexiconTargetSource;


  // matrices to store the lexical probabilities of the Tags
  // we use static array, i.e. can deal only with sentences up to MAX_SENTENCE_LENGTH
  float m_ProbsTagSourceTarget[ MAX_SENTENCE_LENGTH ][ MAX_SENTENCE_LENGTH ];
  float m_ProbsTagTargetSource[ MAX_SENTENCE_LENGTH ][ MAX_SENTENCE_LENGTH ];

  // renormalized probs
  float m_RenProbsTagSourceTarget[ MAX_SENTENCE_LENGTH ][ MAX_SENTENCE_LENGTH ];
  float m_RenProbsTagTargetSource[ MAX_SENTENCE_LENGTH ][ MAX_SENTENCE_LENGTH ];

  
};


class CPhraseAlignerMSTag222:public CPhraseAlignerMSTag
{
public:
  CPhraseAlignerMSTag222();
  virtual ~CPhraseAlignerMSTag222();
  bool AlignPhrase( CSentence *pSourceSentence, CSentence *pTargetSentence,
		    int StartSource, int EndSource,
		    CSortedArray< CPhraseAlignItemMS > & PhraseAlignItems );



};


#endif
