#include <config.h>

#include <algorithm>

#include <SegmentingInfo.hh>


CSegmentingInfo::CSegmentingInfo()
{
  m_SentenceNumber    = -1;
  m_StartPosInSource  = -1;
  m_EndPosInSource    = -1;
  m_StartPosInTarget  = -1;
  m_EndPosInTarget    = -1;
  m_Score             = 999999.99;
}


CSegmentingInfo::CSegmentingInfo( int SentenceNumber,  
								  short StartPosInSource, short EndPosInSource, 
								  short StartPosInTarget, short EndPosInTarget,
								  float Score )
{
  m_SentenceNumber    = SentenceNumber;
  m_StartPosInSource  = StartPosInSource;
  m_EndPosInSource    = EndPosInSource;
  m_StartPosInTarget  = StartPosInTarget;
  m_EndPosInTarget    = EndPosInTarget;
  m_Score             = Score;
}



CSegmentingInfo::CSegmentingInfo( const CSegmentingInfo &SegmentingInfo )
{
  m_SentenceNumber    = SegmentingInfo.m_SentenceNumber;
  m_StartPosInSource  = SegmentingInfo.m_StartPosInSource;
  m_EndPosInSource    = SegmentingInfo.m_EndPosInSource;
  m_StartPosInTarget  = SegmentingInfo.m_StartPosInTarget;
  m_EndPosInTarget    = SegmentingInfo.m_EndPosInTarget;
  m_Score             = SegmentingInfo.m_Score;
}



CSegmentingInfo &
CSegmentingInfo::operator = ( const CSegmentingInfo &SegmentingInfo )
{
  if ( this == &SegmentingInfo ) 
    return *this;

  m_SentenceNumber    = SegmentingInfo.m_SentenceNumber;
  m_StartPosInSource  = SegmentingInfo.m_StartPosInSource;
  m_EndPosInSource    = SegmentingInfo.m_EndPosInSource;
  m_StartPosInTarget  = SegmentingInfo.m_StartPosInTarget;
  m_EndPosInTarget    = SegmentingInfo.m_EndPosInTarget;
  m_Score             = SegmentingInfo.m_Score;

  return *this;
}


ostream& 
operator << ( ostream& OutStream, const CSegmentingInfo &SegmentingInfo  )
{
  OutStream << SegmentingInfo.m_SentenceNumber << " " 
			<< SegmentingInfo.m_StartPosInSource << " "
			<< SegmentingInfo.m_EndPosInSource << " "
			<< SegmentingInfo.m_StartPosInTarget << " "
			<< SegmentingInfo.m_EndPosInTarget << " "
			<< SegmentingInfo.m_Score << endl;
  return OutStream;
}



/*
bool
operator < ( const CSegmentingInfo & First, const CSegmentingInfo & Second )
{
  return First.m_Score < Second.m_Score;
}

bool
CompareValue( const CSegmentingInfo & First, const CSegmentingInfo & Second )
{
  return First.m_Score < Second.m_Score;
}
*/



CSegmentingInfoList::CSegmentingInfoList()
{
  //m_pSegmenter = new CSegmentingInfoList;
}



CSegmentingInfoList::~CSegmentingInfoList()
{
  m_SegmentingInfoList.clear();
}


			
const vector< CSegmentingInfo > & 
CSegmentingInfoList::SegmentingInfoList()
{
  return m_SegmentingInfoList;
}



void
CSegmentingInfoList::AddSegmentingInfo( CSegmentingInfo &SegmentingInfo )
{
  cout << "AddSegmentInfo" << endl << flush;
  m_SegmentingInfoList.push_back( SegmentingInfo );
}



void
CSegmentingInfoList::Resize( int NewSize )
{
  if ( m_SegmentingInfoList.size() > NewSize ) {
    m_SegmentingInfoList.resize( NewSize );
  }
}



void 
CSegmentingInfoList::SortToValue()
{
  sort( m_SegmentingInfoList.begin(), m_SegmentingInfoList.end(), CompareSegmentingInfoByValue() );
}



void 
CSegmentingInfoList::SortToPosition()
{
  sort( m_SegmentingInfoList.begin(), m_SegmentingInfoList.end(), CompareSegmentingInfoByPosition() );
}



void 
CSegmentingInfoList::Display()
{
  vector< CSegmentingInfo >::const_iterator Begin = m_SegmentingInfoList.begin();
  vector< CSegmentingInfo >::const_iterator End = m_SegmentingInfoList.end();
  vector< CSegmentingInfo >::const_iterator Iterator;

  cout << endl;
  cout << "Segmentation Point: sentence, start source, end source, start target, end target, score" << endl;
  cout << "-----------------------------------------" << endl;
  //copy( Begin, End, ostream_iterator< int >( cout, " " ) );
  for ( Iterator = Begin; Iterator != End; ++Iterator ) {
    cout << Iterator->m_SentenceNumber << " " 
		 << Iterator->m_StartPosInSource << " "
		 << Iterator->m_EndPosInSource << " "
		 << Iterator->m_StartPosInTarget << " "
		 << Iterator->m_EndPosInTarget << " "
		 << Iterator->m_Score << endl;
  }
  cout << "-----------------------------------------" << endl;
  cout << endl;


}
