#include <fstream>

#include <SentenceInfo.hh>

using namespace std;

CSentenceInfo::CSentenceInfo()
{
  pLogProbPerWord = NULL;
  pSentenceLength = NULL;
}



CSentenceInfo::~CSentenceInfo()
{
  delete pLogProbPerWord;
  delete pSentenceLength;
}



bool
CSentenceInfo::LoadLogProbPerWord( const char *pFileName )
{

  assert( pFileName );
  ifstream InStream( pFileName );
  int SentenceNumber = 0;

  if ( !InStream.good() ) {
      cerr <<  "CSentenceInfo::LoadLogProbPerWord(): file " << pFileName
		   << " was not opened for read" << endl << flush;
      return false;
  } // endif: error opening file


  // now delete all entries if array exists, otherwise create a new one
  if ( pLogProbPerWord ) {
	pLogProbPerWord->Clear();
  } else {
	pLogProbPerWord = new CNumericalArray< float >;
  }

  while ( !InStream.eof() ) {
	SentenceNumber++;
	InStream >> (*pLogProbPerWord)[ SentenceNumber ];
  }

  InStream.close();

}


bool
CSentenceInfo::LoadSentenceLength( const char *pFileName )
{



}




float
CSentenceInfo::LogProbPerWord( int SentenceNumber )
{
  return (*pLogProbPerWord)[ SentenceNumber ];
}

short
CSentenceInfo::SentenceLength( int SentenceNumber )
{
  return (*pSentenceLength)[ SentenceNumber ];
}


void
CSentenceInfo::DisplayLogProbPerWord( int HowMany )
{
  int Last;

  if ( HowMany >= 0 ) {
    Last = min( HowMany, pLogProbPerWord->MaxIndex() );
  } else {
	Last = pLogProbPerWord->MaxIndex();
  }
  
  for ( int i = pLogProbPerWord->MinIndex(); i <= Last; i++ ) {
	cout << i << " " << (*pLogProbPerWord)[ i ] << endl;
  }

}
