#ifndef __SentenceInfo__
#define __SentenceInfo__

#include <NumericalArray.hh>


class CSentenceInfo
{
public:

  CSentenceInfo();
  ~CSentenceInfo();

  // load the alignment costs
  bool LoadLogProbPerWord( const char *pFileName );

  // load the sentene length info
  bool LoadSentenceLength( const char *pFileName );

  // return the alignment cost per word; smaller costs indicate more 
  // reliable alignment, this should lead to better phrase alignment
  float LogProbPerWord( int SentenceNumber );

  // return the length of the source sentence;  shroter sentences can
  // be aligned faster
  short SentenceLength( int SentenceNumber );

  // display first n values
  void DisplayLogProbPerWord( int HowMany = -1 );

private:
  // the sum of log prob per word for f->e and e->f word alignment
  CNumericalArray < float > * pLogProbPerWord;

  // the length of the source sentence (shorter sentences can be aligned faster)
  CNumericalArray < short > * pSentenceLength;

};


#endif
