/*
 * Map2.cc --
 *	Two-dimensional map implementation
 *
 */

#ifndef _Map2_cc_
#define _Map2_cc_



#ifndef lint
static char Map2_Copyright[] = "Copyright (c) 1999,2002 SRI International.  All Rights Reserved.";
static char Map2_RcsId[] = "@(#)$Header$";
#endif


#include <stdlib.h>
#include <assert.h>
#include <iostream>
#include <new>

#include "Map2.h"

using namespace std;

#undef INSTANTIATE_MAP2

#ifdef USE_SARRAY_MAP2

# include "SArray.h"

# define INSTANTIATE_MAP1(Key1T,Key2T,DataT) \
	typedef SArray<Key2T,DataT> Map2Type; \
	INSTANTIATE_SARRAY(Key1T, Map2Type ); \
	template class Map2< Key1T,Key2T,DataT>; \
	template class Map2Iter<Key1T,Key2T,DataT>; \
	template class Map2Iter2<Key1T,Key2T,DataT>

# define INSTANTIATE_MAP2(Key1T,Key2T,DataT) \
	INSTANTIATE_SARRAY(Key2T, DataT ); \
	INSTANTIATE_MAP1(Key1T,Key2T,DataT)

#else /* ! USE_SARRAY_MAP2 */

# include "LHash.h"

# define INSTANTIATE_MAP1(Key1T,Key2T,DataT) \
	typedef LHash<Key2T,DataT> Map2Type; \
	INSTANTIATE_LHASH(Key1T, Map2Type ); \
	template class Map2< Key1T,Key2T,DataT>; \
	template class Map2Iter<Key1T,Key2T,DataT>; \
	template class Map2Iter2<Key1T,Key2T,DataT>

# define INSTANTIATE_MAP2(Key1T,Key2T,DataT) \
	INSTANTIATE_LHASH(Key2T, DataT ); \
	INSTANTIATE_MAP1(Key1T,Key2T,DataT)

#endif /* USE_SARRAY_MAP2 */


#endif /* _Map2_cc_ */
