/*
 * MemStats.h --
 *	Memory statistics.
 *
 * Copyright (c) 1995, SRI International.  All Rights Reserved.
 *
 * @(#)$Header$
 *
 */

#ifndef _MemStats_h_
#define _MemStats_h_



#include <stddef.h>
#include <iostream>

#pragma warning(disable : 4018) 
#pragma warning(disable : 4244) 
#pragma warning(disable : 4267)
#pragma warning(disable : 4305)
#pragma warning(disable : 4309)



/*
 * The MemStats structure is used to return memory accounting 
 * information from the memstats() methods of various data types.
 */
class MemStats
{
public:
	MemStats();
	void clear();			/* reset memory stats */
	std::ostream &print(std::ostream &stream = std::cerr);
					/* print to std::cerr */

	size_t	total;			/* total allocated memory */
	size_t	wasted;			/* unused allocated memory */
};

#endif /* _MemStats_h_ */
