/*
 * TextStats.h --
 *	Text source statistics
 *
 * TextStats objects are used to pass and accumulate various 
 * statistics of text sources (training or test).
 *
 * Copyright (c) 1995, SRI International.  All Rights Reserved.
 *
 * @(#)$Header$
 *
 */

#ifndef _TextStats_h_
#define _TextStats_h_

#include <iostream>

#include "Prob.h"

class TextStats
{
public:
    TextStats() : prob(0.0), zeroProbs(0),
	numSentences(0), numWords(0), numOOVs(0) {};

    void reset() { prob = 0.0, zeroProbs = 0,
	numSentences = numWords = numOOVs = 0; };
    TextStats &increment(TextStats &stats);

    LogP prob;
    unsigned zeroProbs;
    unsigned numSentences;
    unsigned numWords;
    unsigned numOOVs;
};

std::ostream &operator<<(std::ostream &, TextStats &stats);

#endif /* _TextStats_h_ */

