/*
 * Trie.cc --
 *	The trie class implementation.
 *
 */

#ifndef _Trie_cc_
#define _Trie_cc_

#ifndef lint
static char Trie_Copyright[] = "Copyright (c) 1995-1998 SRI International.  All Rights Reserved.";
static char Trie_RcsId[] = "@(#)$Header$";
#endif

#include <stdlib.h>
#include <assert.h>
#include <iostream>
#include <new>

#include "Trie.h"

using namespace std;

#undef INSTANTIATE_TRIE

#ifdef USE_SARRAY_TRIE

# include "SArray.h"

# define INSTANTIATE_TRIE(KeyT,DataT) \
	typedef Trie<KeyT,DataT> TrieType; \
	INSTANTIATE_SARRAY(KeyT, TrieType ); \
	template class Trie< KeyT,DataT>; \
	template class TrieIter<KeyT,DataT>; \
	template class TrieIter2<KeyT,DataT>

#else /* ! USE_SARRAY_TRIE */

# include "LHash.h"

# define INSTANTIATE_TRIE(KeyT,DataT) \
	typedef Trie<KeyT,DataT> TrieType; \
	INSTANTIATE_LHASH(KeyT, TrieType ); \
	template class Trie< KeyT,DataT>; \
	template class TrieIter<KeyT,DataT>; \
	template class TrieIter2<KeyT,DataT>

#endif /* USE_SARRAY_TRIE */
   


#endif /* _Trie_cc_ */
