/*
 * MemStats.h --
 *	Memory statistics.
 *
 * Copyright (c) 1995, SRI International.  All Rights Reserved.
 *
 * @(#)$Header$
 *
 */

#ifndef _MemStats_h_
#define _MemStats_h_

#include <stddef.h>
#include <iostream>

/*
 * The MemStats structure is used to return memory accounting 
 * information from the memstats() methods of various data types.
 */
class MemStats
{
public:
	MemStats();
	void clear();			/* reset memory stats */
	ostream &print(ostream &stream = cerr);
					/* print to cerr */

	size_t	total;			/* total allocated memory */
	size_t	wasted;			/* unused allocated memory */
};

#endif /* _MemStats_h_ */
