#include <string.h>
#include <stdlib.h>
#include <config.h>
#include <fortify.h>
 /*
 *
 *  DeEncoder.cc
 *   
 *  header file for class to do encoding identification and Transliteration
 *  on utf-8 or cp-1256 or ascii encoded text files.
 *
 *
 *  conversion of the perl encoding script
 *  /nfs/progress3/Users/Alicia/Demo/id_code.pl
 *
 * 
 *  akt. Oct 2003
 */


#include <stdio.h>
#include <wchar.h>
  
#include <stddef.h>
#include <locale.h>
#include <stdlib.h>
#include <string.h>
#include <iconv.h>
#include <errno.h>

#include "ConvertUTF.c"
#include "DeEncoder.h"


DeEncoder::DeEncoder(){}

DeEncoder::~DeEncoder(){}

int DeEncoder::Mem_ID_and_Transliterate( char *line, char *result) {
 
  int encoding;

  /* determine whether this is utf or cp1256 */
  encoding = id_encode( line );
  
  result[0] = '\0';
  if( (encoding == UTF) || (encoding == ASCII) ){

	/*printf("Converting UTF\n\n");*/
    
    process_next_line( line, result );
  }
  else if( encoding == CP1256 ){

	/*printf("Converting CP1256\n\n");*/
	
	size_t av = (size_t)AR_LINESIZE;
	char utf_t_out [AR_LINESIZE];
	char * utf_t_out_ptr = (char*)utf_t_out;
	cp2utf( line, utf_t_out_ptr, av);
	
	process_next_line( utf_t_out_ptr, result );

  }
  
  return 0;
}



int DeEncoder::process_next_line( char *line, char *th_result )
{
  /*printf("Calling process_next on %s\n", line);*/
	
  int nextARchar[AR_CHSIZE];
  char nextDarwishchar[2];
  int ch = 0, i= 0, l=0;
  int char_state = 0, nextARpos = 0, ARcharcount = 0, ARconvresult=0;
  int ret = UTF;

  /* reset the character storage for this line */
  for( i = 0; i<AR_CHSIZE; i++) { nextARchar[i] = 0; }
  for( i = 0; i<1; i++) { nextDarwishchar[i] = 0; }
  
  /* loop through chars of the current line and print after transliteration 
   *
   */
  int cur_string_pos =0;
  l = strlen( line );
  char fullDarwishline[AR_LINESIZE];
  
  while(cur_string_pos < l) {           /* string input version */
	
	/* take the next byte off of the line we're reading */
	
	ch = (unsigned char)line[cur_string_pos];
	cur_string_pos++;

	/* bytes in the range of ASCII characters */
	if( (0x00 <= ch) && (ch <= 0x7F) ){

	  
	  /* print the previous ar char if there was one */
	  process_and_print_next_ARchar( nextARchar, nextDarwishchar );
	  strcat( th_result, nextDarwishchar);
	  nextDarwishchar[0] = '\0';

	  /* clear out the array for the next utf8 char */
	  for( i = 0; i<AR_CHSIZE; i++){  nextARchar[i] = 0; }
	  nextARpos = 0;
	  
	  char* ch_p = (char*)&ch;
	  char ch_with_punctcheck[AR_CHSIZE];
	  strcpy(ch_with_punctcheck, ch_p);
	  /* just print this ascii char the way it is, no conversion */
	  /* but do some pp on it- if it's punctuation or a number separate it from the other txt */
	  /*do_punct_check( ch_with_punctcheck );*/
	  strcat( th_result, ch_with_punctcheck );
	}
	/* bytes in the range for first byte of a utf8 character */
	else if( (0xC2 <= ch) && (ch <= 0xF3) ){ 		
	  
	  /* print the previous ar char if there was one */
	  process_and_print_next_ARchar( nextARchar, nextDarwishchar );
	  strcat( th_result, nextDarwishchar);
	  nextDarwishchar[0] = '\0';

	  /* clear out the array for the next utf8 char */
	  for( i = 0; i<AR_CHSIZE; i++){  nextARchar[i] = 0; }
	  
	  /* put the current byte in the first slot of the next utf8 char */
	  nextARchar[0] = ch;   
	  nextARpos = 1;
	  ARcharcount++;
	}
	/* bytes in range for 2nd or 3rd byte of a utf8 char */
	else if( (0x80 <= ch) && (ch <= 0xBF) ){

	  if( nextARpos < AR_CHSIZE ){
		
		/* store this in the next slot in the utf8 char and increment 
		 * the current position in the utf8 char 
		 */
		nextARchar[nextARpos] = ch;
		nextARpos++;
	  }
	  else{  printf( "Illegal character sequence: arpos is %d\n", nextARpos ); }
	  
	}
	/* bytes in the range for cp 1256 characters */
	else{ ret = CP1256;	}
	
  }

  /* 
   * check to make sure the strings we're returning are \0 delimited
   */
  if( nextDarwishchar[0] != '\0' ){ 
	strcat( th_result, nextDarwishchar );
	printf( "Adding %s to the buffer\n", nextDarwishchar);
  }
  int len = strlen(th_result);
  /*printf("strlend is %d\n", len);*/
  
  if(th_result[len] != '\0'){ 
	if( len < AR_LINESIZE ){ printf("terminating\n"); th_result[len] = '\0'; }
	else{ printf("oops\n"); th_result[AR_LINESIZE] = '\0';}
  }
  /*printf("Setting the result to [%s] in loc %i\n", th_result, &th_result); */
   
  return ret;
}


void DeEncoder::do_punct_check( char *ch_with_punctcheck ){
  /*

  if( (strcmp( ch_with_punctcheck, "." )) ||
	  (strcmp( ch_with_punctcheck, "?" )) ||
	  (strcmp( ch_with_punctcheck, ";" )) ||
	  (strcmp( ch_with_punctcheck, "\"" )) ||
	  (strcmp( ch_with_punctcheck, "\'" )) ||
	  (strcmp( ch_with_punctcheck, ":" )) ||
	  (strcmp( ch_with_punctcheck, "(" )) ||
	  (strcmp( ch_with_punctcheck, ")" )) ||
	  (strcmp( ch_with_punctcheck, "-" )) )
  {
	if( strlen(ch_with_punctcheck) > 3 ){}
	  


  }
  */
}



int DeEncoder::id_encode( char *line )
{

  int consec_ut = 0, ch = 0, i= 0, l=0;
  int ret = ASCII;

  int state=0;

  /* state2 - starting a utf8 char, need at least
   * one more byte.
   *
   * state1 - read an ascii char.  can't see the 
   * middle of a utf8 char now.
   *
   * state3 - utf8 middle following a utf8 start or
   * middle.  still ok.
   *
   * state4 - read an 'other' char.  exit and go to 
   * cp1256
   *
   */


  /* loop through chars of the current line and check hex vals of the bytes
   * if we see more than 3 utf bytes in a row we know we've got illegal utf chars
   */
  int cur_string_pos =0;
  l = strlen( line );

  while(cur_string_pos < l) { 
	
	/* take the next byte off of the line we're reading 
	 *
	 */
	ch = (unsigned char)line[cur_string_pos];
	cur_string_pos++;


	/* 
	 * bytes in the range of ASCII characters 
	 */
	if( (0x00 <= ch) && (ch <= 0x7F) ){	

	  /* as long as we aren't following a beg-of-utf character */
	  if( state  == 2 ){  ret = CP1256;  return ret; }

	  state = 1;
	  consec_ut = 0;
	}
	/* 
	 * bytes in the range for first byte of a utf8 character 
	 */
	else if( (0xC2 <= ch) && (ch <= 0xF3) ){ 

	  /* if we just saw anything but another first byte, we're ok */
	  if( state == 2 ){  ret = CP1256;  return ret; }
	  
	  ret = UTF;	
	  consec_ut = 1;
	  state = 2;
	}
	/* bytes in range for 2nd or 3rd byte of a utf8 char */
	else if( (0x80 <= ch) && (ch <= 0xBF) ){ 
	  
	  /* if we just saw a utf beginning or a utf middle, we're ok 
	   *
	   */
	  if( state == 2 ){ state = 3;}
	  else if( (state = 3) && ( consec_ut < 3 ) ){}
	  else{ ret = CP1256;  return ret; }

	  ret = UTF; 
	  consec_ut++;
	}
	else{ 

	  /* if we see anything not in the utf-8 range, try treating it as cp1256*/
	  ret = CP1256;  return ret;
	}

	/* if we hit >4 utf chars in a row the encoding is not legal utf,
	 * for purposes of this script we assume it's cp1256 then.
	 */
	if( consec_ut > 5 ){ ret = CP1256;  return ret; }
  }
  return ret;
}



int DeEncoder::process_and_print_next_ARchar( int *nextchar, char *darwish_result){

  int i, n;
  int CP_12 = 0;


  //cout << "process _and_print_next_ARchar" << nextchar << endl;

  /* call utf8 to utf32 on the full utf8 char and then 
   * do a table lookup on the result
   *
   */
  ConversionResult result;
  UTF32 utf32_buf[2], utf32_result[2];
  UTF8 utf8_buf[8];
  UTF32 *utf32SourceStart, *utf32TargetStart;
  UTF8 *utf8SourceStart, *utf8TargetStart;

  /* Reset some result buffer pointers  */
  utf32_buf[0] = 0; utf32_buf[1] = 0;
  utf32_result[0] = utf32_result[1] = 0;
  
  /* copy the values we want into the current input buffer */
  for( i=0; i<AR_CHSIZE; i++){
    utf8_buf[i] = nextchar[i];
  }
  utf32SourceStart = utf32_buf; utf32TargetStart = utf32_result;
  utf8TargetStart = utf8SourceStart = utf8_buf;

  
  /*
   * Adapted from unicode_src/ConvertUTF_harness.c
   *
   * Convert the current utf8 string to utf32, i.e. unicode.
   * result is a hex digit in the int* utf32_result.
   */
  result = ConvertUTF8toUTF32((const UTF8 **) &utf8SourceStart, 
							  &(utf8_buf[trailingBytesForUTF8[utf8_buf[0]]+1]), 
							  &utf32TargetStart, 
							  &(utf32_result[1]), 
							  strictConversion);

  switch (result) {
  default: fprintf(stderr, "Test03B fatal error: result %d for input %08x\n", result, utf32_buf[0]); exit(1);
  case conversionOK: break;
  case sourceExhausted: printf("sourceExhausted\t"); break;
  case targetExhausted: printf("targetExhausted\t"); break;
  case sourceIllegal: printf("sourceIllegal\t"); break;
  }
  if (result != conversionOK) {

  }

  /* get the darwish char for this unicode string
   *
   *
   */
  if( nextchar[0] != 0 ){
	get_utf_darwish_lookup( utf32_result[0], darwish_result );
  }
  else{
	darwish_result[0] = '\0';
  }
  
  return 0;
}




int DeEncoder::get_utf_darwish_lookup ( int unicode_in, char *darwish_out ){

  /*printf( "Getting lookup \n");*/

  switch (unicode_in) {
  default: break;
  /*default: printf ("No match for the unicode 0x%08x \n", unicode_in ); break;*/
  case 0x00000621: darwish_out[0] = 'A'; darwish_out[1] = '\0'; break;
  case 0x00000622: darwish_out[0] = 'A'; darwish_out[1] = '\0'; break;
  case 0x0000623:  darwish_out[0] =  'A'; darwish_out[1] = '\0'; break;
  case 0x0000624:  darwish_out[0] =  'A'; darwish_out[1] = '\0'; break;
  case 0x0000625:  darwish_out[0] = 'A'; darwish_out[1] = '\0'; break;
  case 0x0000626:  darwish_out[0] = 'A'; darwish_out[1] = '\0'; break;
  case 0x0000627:  darwish_out[0] =  'A'; darwish_out[1] = '\0'; break;
  case 0x0000628:  darwish_out[0] =  'b'; darwish_out[1] = '\0'; break;
  case 0x0000629:  darwish_out[0] =  'p'; darwish_out[1] = '\0'; break;
  case 0x000062A:  darwish_out[0] =  't'; darwish_out[1] = '\0'; break;
  case 0x000062B:  darwish_out[0] =   'v'; darwish_out[1] = '\0'; break;
  case 0x000062C:  darwish_out[0] =  'j'; darwish_out[1] = '\0'; break;
  case 0x000062D:  darwish_out[0] =  'H'; darwish_out[1] = '\0'; break;
  case 0x000062E:  darwish_out[0] =  'x'; darwish_out[1] = '\0'; break;
  case 0x000062F:  darwish_out[0] =  'd'; darwish_out[1] = '\0'; break;
  case 0x0000630:  darwish_out[0] =  'O'; darwish_out[1] = '\0'; break;
  case 0x0000631:  darwish_out[0] =  'r'; darwish_out[1] = '\0'; break;
  case 0x0000632:  darwish_out[0] =  'z'; darwish_out[1] = '\0'; break;
  case 0x0000633:  darwish_out[0] =  's'; darwish_out[1] = '\0'; break;
  case 0x0000634:  darwish_out[0] =  'P'; darwish_out[1] = '\0'; break;
  case 0x0000635:  darwish_out[0] =  'S'; darwish_out[1] = '\0'; break;
  case 0x0000636:  darwish_out[0] =  'D'; darwish_out[1] = '\0'; break;
  case 0x0000637:  darwish_out[0] =  'T'; darwish_out[1] = '\0'; break;
  case 0x0000638:  darwish_out[0] =  'Z'; darwish_out[1] = '\0'; break;
  case 0x0000639:  darwish_out[0] =  'E'; darwish_out[1] = '\0'; break;
  case 0x000063A:  darwish_out[0] =  'g'; darwish_out[1] = '\0'; break;
  case 0x0000640:  darwish_out[0] =  '-'; darwish_out[1] = '\0'; break;
  case 0x0000641:  darwish_out[0] =  'f'; darwish_out[1] = '\0'; break;
  case 0x0000642:  darwish_out[0] = 'q'; darwish_out[1] = '\0'; break;
  case 0x0000643:  darwish_out[0] =  'k'; darwish_out[1] = '\0'; break;
  case 0x0000644:  darwish_out[0] =  'l'; darwish_out[1] = '\0'; break;
  case 0x0000645:  darwish_out[0] =  'm'; darwish_out[1] = '\0'; break;
  case 0x0000646:  darwish_out[0] =  'n'; darwish_out[1] = '\0'; break;
  case 0x0000647:  darwish_out[0] =  'h'; darwish_out[1] = '\0'; break;
  case 0x0000648:  darwish_out[0] =  'w'; darwish_out[1] = '\0'; break;
  case 0x0000649:  darwish_out[0] =  'y'; darwish_out[1] = '\0'; break;
  case 0x000064A:  darwish_out[0] = 'y'; darwish_out[1] = '\0'; break;
  case 0x000064B:  darwish_out[0] =  '\0'; darwish_out[1] = '\0'; break;
  case 0x000064C:  darwish_out[0] =  '\0'; darwish_out[1] = '\0'; break;
  case 0x000064D:  darwish_out[0] =  '\0'; darwish_out[1] = '\0'; break;
  case 0x000064E:  darwish_out[0] =  '\0'; darwish_out[1] = '\0'; break;
  case 0x000064F:  darwish_out[0] =  '\0'; darwish_out[1] = '\0'; break;
  case 0x0000650:  darwish_out[0] =  '\0'; darwish_out[1] = '\0'; break;
  case 0x0000651:  darwish_out[0] =   '\0'; darwish_out[1] = '\0'; break;
  case 0x0000652:  darwish_out[0] =  '\0'; darwish_out[1] = '\0'; break;
  case 0x0000670:  darwish_out[0] = '\0'; darwish_out[1] = '\0'; break;
  case 0x0000671:  darwish_out[0] =  '\0'; darwish_out[1] = '\0'; break;
	/*case 0x000066A:  darwish_out[0] =  '%'; darwish_out[1] = '\0'; break;*/
  case 0x000066B:  darwish_out[0] =  '.'; darwish_out[1] = '\0'; break;
  case 0x000066C:  darwish_out[0] = ','; darwish_out[1] = '\0'; break;
  }
}


/*
 * cp2utf 
 * convert a buffer of chars in cp1256 to utf-8 
 * so that we can i.d. the characters based on this code.
 *
 *
 * fd is the filehandle
 * outbuf is the buffer we're writing the converted string to
 * avail is the size of outbuf
 *
 * call with 
 * FILE* fd
 * char buffer[AR_LINESIZE]
 * size_t avail = (size_t) AR_LINESIZE;
 *
 */
int DeEncoder::cp2utf(char* inbuf, char *outbuf, size_t avail) {
  size_t insize = strlen( inbuf );
  char *wrptr = outbuf;
  int result = 0;
  iconv_t cd;

  cd = iconv_open ("UTF8", "CP1256");
  if (cd == (iconv_t) -1)
    {
      /* Something went wrong.  */
      if (errno == EINVAL){
        perror ("conversion from CP1256 to UTF not available" );
	  }
      else
        perror ("iconv_open");

      /* Terminate the output string.  */
      *outbuf = '\0';

      return -1;
    }

  size_t nread;
  size_t nconv;
  char *inptr = inbuf;

  /* initialize the iconv descriptor */
  iconv (cd, NULL, NULL, &wrptr, &avail);
  if (nconv == (size_t) -1) {
	printf( "Warning: failed to initialize the iconv descriptor\n");
  }

  /* Do the conversion.  */
  nconv = iconv(cd, &inptr, &insize, &wrptr, &avail);

  if (nconv == (size_t) -1) {
	  /* Not everything went right.  It might only be
		 an unfinished byte sequence at the end of the
		 buffer.  Or it is a real problem.  */
	if (errno == EINVAL){
		/* This is harmless.  Simply move the unused
		   bytes to the beginning of the buffer so that
		   they can be used in the next round.  */
		//memmove (inbuf, inptr, insize);
	}
	  else
		{
		  /* It is a real problem.  Maybe we ran out of
			 space in the output buffer or we have invalid
			 input.  In any case back the file pointer to
			 the position of the last processed byte.  */
		  //lseek (fd, -insize, SEEK_CUR);
		  //result = -1;
		  //break;
		}
  }
  else{ /*printf( "Successful call to iconv: %s\n", wrptr );*/ }


  /* Terminate the output string.  */
  if (avail >= sizeof (char))
    *((char*) wrptr) = '\0';

  if (iconv_close (cd) != 0)
    perror ("iconv_close");

  return (char*) wrptr - outbuf;
}

