 /*
 *
 *  DeEncoder.h
 *   
 *  header file for class to do encoding identification and Transliteration
 *  on utf-8 or cp-1256 or ascii encoded text files.
 *
 *
 *  conversion of the perl encoding script
 *  /nfs/progress3/Users/Alicia/Demo/id_code.pl
 *
 * 
 *  akt. Oct 2003
 */



#ifndef DE_ENCODE_H
#define DE_ENCODE_H



class DeEncoder{


 public:
   DeEncoder();
   ~DeEncoder();
   int Mem_ID_and_Transliterate( char *line, char *result);


 private:
   /* we know we'll always need 4 bytes for an ar char */
   static const int AR_CHSIZE = 4;
   static const int AR_LINESIZE = 10000;

   /* identifiers for each of the encodings we'll deal with */
   static const int UTF = 0;
   static const int CP1256 = 1;
   static const int ASCII = 2;
   static const int OTHER_ENC = 3;


   /* function declarations */
   int process_and_print_next_ARchar( int *nextchar, char *darwish_result);
   int get_utf_darwish_lookup ( int unicode_in, char *darwish_out );
   int process_next_line( char *line, char *result );
   int cp2utf (char *inbuf, char *outbuf, size_t avail);
   void do_punct_check( char *ch_with_punctcheck );
   int id_encode( char *line );
};


#endif
