#include <string.h>
/*
 *  TranslationServer.cc
 *  TranslateMM
 *
 *  Created by Anton D'Auria on 12/5/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include <iostream>
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <netdb.h>

#include <TranslationServerSocket.hh>
// --------------------------------------------------------------------------------
// start socket communication for Chil Demo
// --------------------------------------------------------------------------------
using namespace std;

TranslationServerSocket::TranslationServerSocket()
{
	impl = new TranslationServerSocket_impl;
	impl->server = -1;
	impl->client = -1;
}

TranslationServerSocket::~TranslationServerSocket()
{
	if (impl->client != 1)
		close(impl->client);
	if (impl->server != -1)
		close(impl->server);
	delete impl;
}

int TranslationServerSocket::start(char* address, int port)
{
	impl->server = socket(PF_INET, SOCK_STREAM, 0);
	if (impl->server == -1)
		return -1; // socket() failed
  
	impl->addr.sin_addr.s_addr = inet_addr(address);
	impl->addr.sin_port = htons(port);
	impl->addr.sin_family = AF_INET;
  
	if (bind(impl->server, (struct sockaddr*) &impl->addr, sizeof(impl->addr)) == -1)
		return -1; // bind() failed
  
	if (listen(impl->server, 3) == -1)
		return -1; // listen() failed
  
	return impl->server;
} /* start */

int TranslationServerSocket::getSource(char* source)
{
	int len, r;
	socklen_t addr_len;
  
	*source = 0;
	if (impl->server == -1)
		return -1;
  
	while (true) {
    
		while (impl->client == -1) {
      
			cerr << "> Waiting for client...\n";
      
			addr_len = sizeof(impl->client_addr);
			impl->client = accept(impl->server, (struct sockaddr*) &impl->client_addr, &addr_len);
			if (impl->client != -1) {
				// client from inet_ntoa(impl->client_addr.sin_addr)
				cerr << "> Client accepted from " << inet_ntoa(impl->client_addr.sin_addr) << endl;
				break;
			}
		}
    
		len = 0;
    
		while (len < TRANSLATION_BUFFER_SIZE - 2) {
      
			r = recv(impl->client, source + len, 1, 0);
			if (r <= 0) {
        
				if (r == 0)
					cerr << "> Client has disconnected\n";
				close(impl->client);
				impl->client = -1;
				break;
			}
			if (source[len++] == '\n')
				break;
		}
    
		if (impl->client != -1) {
      
			source[--len] = '\0';
			cerr << "> Received for translation: " << source << endl;
			return 0;
		}
	}
} /* getSource */

int TranslationServerSocket::sendTarget(const char* target)
{
	size_t len, bytes;
	char* p;
	char buffer[TRANSLATION_BUFFER_SIZE];
  
	if (impl->server == -1)
		return -1;
	if (impl->client == -1)
		return -1;
  
	strncpy(buffer, target, TRANSLATION_BUFFER_SIZE - 3);
	len = strlen(buffer);
	if (buffer[len] != '\n') {
		strcat(buffer, "\n");
		len += strlen("\n");
	}
  
	cerr << "> Sending translation: " << buffer;
  
	p = buffer;
  
	while (len > 0) {
    
		bytes = send(impl->client, p, len, 0);
		if (bytes == -1)
			return -1; // send() failed
		p += bytes;
		len -= bytes;
	}
  
	return 0;
} /* sendTarget */

// --------------------------------------------------------------------------------
// end socket communication for Chil Demo
// --------------------------------------------------------------------------------
