#ifndef __HASH__
#define __HASH__

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#ifdef HAVE_EXT_HASH_MAP
#include <ext/hash_map>
using __gnu_cxx::hash_map;
using __gnu_cxx::hash;
#else
#include <hash_map>
using std::hash_map;
using std::hash;
#endif

#ifdef HAVE_EXT_HASH_SET
#include <ext/hash_set>
using __gnu_cxx::hash_set;
using __gnu_cxx::hash;
#else
#include <hash_set>
using std::hash_set;
using std::hash;
#endif

#include <string>
#include <String.hh>

using std::string;


struct StringHasher
{
  hash< const char* > H;

  size_t operator()( const string &S ) const
  {
	return H( S.c_str() );
  }

  size_t operator()( const CString &S ) const
  {
	return H( (const char *)S );
  }
};



struct StringComparer
{
  bool operator()(const char* s1, const char* s2) const
  {
    return strcmp( s1, s2 ) == 0;
  }

  bool operator()(const string s1, const string s2) const
  {
    return strcmp( s1.c_str(), s2.c_str() ) == 0;
  }

  bool operator()(const CString s1, const CString s2) const
  {
    return strcmp( (const char *)s1, (const char *)s2 ) == 0;
  }
};



#endif
