#include <config.h>

//========================= Kopf ====================================
//
//
//
//
//

//========================= Implementierungsabhngigkeiten ==========

#include <assert.h>
#include <math.h>
#include <string.h>

//#include "trace.hh"
//#include "array.hh"



//========================= Implementierung =========================

//--------------------------------------------------------------------
//       CNumericalArray1D :: operator =
// 
/*
template<class T>
CNumericalArray1D<T> &
CNumericalArray1D<T>::operator = ( const CNumericalArray1D<T> &Array )
{
  if ( this == &Array ) 
    //-- Kopie auf sich selber kann ignoriert werden
    return *this;

  if ( !Array.IsValid() ) {
    //-- Quelle ist bereits ungueltig. Eigenes Objekt wird ebenfalls
    //   ungueltig
    Invalidate();
    return *this;
  }
   
  //-- Evtl. gespeicherte Elemente loeschen
  Clear();

  // Grenzen gleich richtig setzten, erspart umkopieren
  if ( !AssureBoundaries( Array.GetMinIndex(), Array.GetMaxIndex() ) ) 
    //-- nicht ausreichend Speicher fuer count Elemente
    //   assureCount hat Objekt bereits auf invalid gesetzt
    return *this;

  // jetzt die einzelnen Elemente kopieren
  for ( int i = Array.GetMinIndex(); i <= Array.GetMaxIndex(); i++ )
    (*this)[i] = Array[i];

  return *this;
} // op =

*/


template<class T>
inline 
bool CNumericalArray1D<T>::operator == ( const CNumericalArray1D<T> & Array ) const
{
  //cout << "CNumericalArray::operator ==: compare " << *this << " with " << Array << endl;
  int i = this->MinIndex();
  int j = Array.MinIndex();

  while ( i <= this->MaxIndex() && j <= Array.MaxIndex() ) {
	if ( this->GetAt( i ) != Array.GetAt( i ) ) {
	  return false;
	}
	i++;
	j++;
  }

  return this->Size() == Array.Size();

}


template<class T>
inline 
bool CNumericalArray1D<T>::operator < ( const CNumericalArray1D<T> & Array ) const
{
  //cout << "CNumericalArray::operator <: compare " << *this << " with " << Array << endl;
  int i = this->MinIndex();
  int j = Array.MinIndex();

  while ( i <= this->MaxIndex() && j <= Array.MaxIndex() ) {
	if ( this->GetAt( i ) != Array.GetAt( i ) ) {
	  return this->GetAt( i ) < Array.GetAt( i ) ;
	}
	i++;
	j++;
  }

  return this->Size() < Array.Size();
}


template<class T>
inline 
bool CNumericalArray1D<T>::operator > ( const CNumericalArray1D<T> & Array ) const
{
  //cout << "CNumericalArray::operator >: compare " << *this << " with " << Array << endl;

  int i = this->MinIndex();
  int j = Array.MinIndex();

  while ( i <= this->MaxIndex() && j <= Array.MaxIndex() ) {
	if ( this->GetAt( i ) != Array.GetAt( i ) ) {
	  return this->GetAt( i ) > Array.GetAt( i ) ;
	}
	i++;
	j++;
  }

  return this->Size() > Array.Size();
}




//--------------------------------------------------------------------
//       CNumericalArray1D :: Add
//
template<class T>
inline
void
CNumericalArray1D<T>::Add( const T Value )
{
  //Trace( 3, "CNumericalArray1D<T>::Add " << Value);

  for ( int i = this->m_MinIndex; i <= this->m_MaxIndex; i++ ) {
    //Trace( 5, "i = " << i );
    this->m_pElements[i] += Value;
  }
}



//--------------------------------------------------------------------
//       CNumericalArray1D :: Sub
//
template<class T>
inline
void
CNumericalArray1D<T>::Sub( const T Value )
{
  //Trace( 3, "CNumericalArray1D<T>::Sub " << Value);

  for ( int i = this->m_MinIndex; i <= this->m_MaxIndex; i++ )
    this->m_pElements[i] -= Value;
}



//--------------------------------------------------------------------
//       CNumericalArray1D :: Mul
//
template<class T>
inline
void
CNumericalArray1D<T>::Mul( const T Value )
{
  //Trace( 3, "CNumericalArray1D<T>::Mul " << Value);

  for ( int i = this->m_MinIndex; i <= this->m_MaxIndex; i++ )
    this->m_pElements[i] *= Value;
}



//--------------------------------------------------------------------
//       CNumericalArray1D :: Div
//
template<class T>
inline
void
CNumericalArray1D<T>::Div( const T Value )
{
  //Trace( 3, "CNumericalArray1D<T>::Div " << Value);

  assert( Value );

  for ( int i = this->m_MinIndex; i <= this->m_MaxIndex; i++ )
    this->m_pElements[i] /= Value;
}



//--------------------------------------------------------------------
//       CNumericalArray1D :: Inc
//
template<class T>
inline
void
CNumericalArray1D<T>::Inc( int Index )
{
  //Trace( 3, "CNumericalArray1D<T>::Inc " << Index);

  this->m_pElements[ Index ] += 1;

}



//--------------------------------------------------------------------
//       CNumericalArray1D :: Dec
//
template<class T>
inline
void
CNumericalArray1D<T>::Dec( int Index )
{
  // Trace( 3, "CNumericalArray1D<T>::Dec " << Index);

  this->m_pElements[ Index ] -= 1;

}


//--------------------------------------------------------------------
//       CNumericalArray1D :: Sum
//
template<class T>
inline
T
CNumericalArray1D<T>::Sum() const
{
  T Sum = (T)0;

  for ( int i = this->m_MinIndex; i <= this->m_MaxIndex; i++ ) {
    Sum += this->m_pElements[ i ];
  }

  return Sum;
}




//--------------------------------------------------------------------
//       CNumericalArray1D :: Log
//
template<class T>
inline
void
CNumericalArray1D<T>::Log()
{
  // Trace( 3, "CNumericalArray1D<T>::Log" );

  for ( int i = this->m_MinIndex; i <= this->m_MaxIndex; i++ ) {
    assert( this->m_pElements[i] > 0 );
    this->m_pElements[i] = log(  this->m_pElements[i] );
  }   
}



//--------------------------------------------------------------------
//       CNumericalArray1D :: Log
//
template<class T>
inline
CNumericalArray1D<T>
CNumericalArray1D<T>::operator +( const T Value )
{
  // Trace( 3, "CNumericalArray1D<T>::operator +" );

  CNumericalArray1D<T> NewArray;
  NewArray.AssureBoundaries( this->m_MinIndex, this->m_MaxIndex );

  for ( int i = this->m_MinIndex; i <= this->m_MaxIndex; i++ ) {
    NewArray.m_pElements[i] = this->m_pElements[i] + Value;
  }

  return NewArray;
}





//--------------------------------------------------------------------
//       CNumericalArray2D :: Inc
//
template<class T>
inline
void
CNumericalArray2D<T>::Inc( int Index1, int Index2 )
{
  // Trace( 3, "CNumericalArray2D<T>::Inc " << Index1 << " " << Index2 );

  assert( Index1 >= this->m_Data.MinIndex() );
  assert( Index1 <= this->m_Data.MaxIndex() );

  CNumericalArray1D<T> & Array = this->m_Data[ Index1 ];
  Array.Inc( Index2 );

  //m_Data[ Index1 ].Inc( Index2 );
  //m_pElements[ Index ] += 1;

}



template<class T>
inline CNumericalArray1D<T> &
CNumericalArray2D<T>::GetRow( int Index )
{
  //-Trace(5, "GetRow");
  return (CNumericalArray1D<T> &) this->m_Data[ Index ];
}
