//
// $Rev: 3922 $
// $LastChangedData$
//
// C_Ngram class is to store an n-gram as an array of IndexType
// class provides functions to append new word and access some words in the n-gram
//
// By Joy, joy@cs.cmu.edu
// July 18, 2007
//

#if !defined(__HEADER_NGRAM__)
#define __HEADER_NGRAM__

#include "shared.h"
#include <vector>

using namespace std;

class C_Ngram
{
public:	
	bool chopFirstWord();
	void appendOneWord(IndexType nextWord);
	IndexType returnWordAt(int index);

	bool operator<(const C_Ngram & ) const;
	bool operator==(const C_Ngram &) const;
	void operator=(const C_Ngram &);

	int returnSize();

	C_Ngram();
	C_Ngram(IndexType * ngram, unsigned char n);
	C_Ngram(vector<IndexType> & ngram);
	C_Ngram(const C_Ngram & obj, IndexType nextWord);
	C_Ngram(const C_Ngram & obj);	//copy constructor
	
	~C_Ngram();
private:
	void freeMemory();
	void copy(const C_Ngram & obj);


	unsigned char size;
	IndexType * ngram;
	
};

#endif //define __HEADER_NGRAM__
