#include <config.h>



#ifndef __utils_hh__
#define __utils_hh__


#include <stdlib.h>
#include <time.h>
#include <iostream>

#define EXIT_IF(C, M, V) {if (C) \
			 {cerr << endl << "ERROR: " << M << "... exiting" << endl; \
			    exit (V);}}

#define ABORT_IF(C, M) {if (C) \
			 {cerr << endl << "ERROR: " << M << "... aborting" << endl; \
			    abort();}}

#define RETURN_IF(C, M, V) {if (C) \
			 {cerr << endl << M  << endl; \
			    return (V);}}

#define MAX(E, A, B) {E = ((A) > (B)) ? (A) : (B);}
#define MIN(E, A, B) {E = ((A) < (B)) ? (A) : (B);}



void inline
PrintTime( const char * Message )
{
  time_t Time = time(NULL);
  char *String;
  String = asctime( localtime( &Time ) );
  std::cout << "TIME: " << Message << " " << String << std::endl << std::flush;
}

#endif










