// _JoyString.h: interface for the C_String class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX__JOYSTRING_H__FBD2CB6D_74AC_4DFE_B1EC_071C0492438C__INCLUDED_)
#define AFX__JOYSTRING_H__FBD2CB6D_74AC_4DFE_B1EC_071C0492438C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdio.h"

class C_String  
{
public:
	void prepend(const C_String & obj);
	void toLowerCase();
			
	char getCharAtPos(int) const;
	void clear();
	char * toString() const;
	int length() const;
	void print2stream(FILE *);

	C_String(const C_String & obj1, const C_String & obj2);
	C_String(C_String const&);
	C_String(char *);
	C_String(char *str1, int len);
	C_String();

	bool operator==(const C_String &) const;
	bool operator!=(const C_String &) const;
	bool operator<(const C_String &) const;
	bool operator>(const C_String &obj1) const;
	void operator=(const C_String &strObj2);
	
	void appending(const C_String & obj);
	void appending(const char nextChar);

	virtual ~C_String();

private:
	void freeContent();
	void copy(const C_String &);
	void copy(const C_String &strObj, int copyLen);

	bool hasContent;
	char * content;
};

#endif // !defined(AFX__JOYSTRING_H__FBD2CB6D_74AC_4DFE_B1EC_071C0492438C__INCLUDED_)
