#include <config.h>

// CAlignProb

// Class for alignment propabilities, base class


#ifndef __AlignProb__
#define __AlignProb__

#include <Types.hh>
//#include "NumericalArray.hh"


class CAlignProb
{
public:
  CAlignProb();
  virtual ~CAlignProb();

  // init with uniform probabilities, according to limits and margins
  virtual void Init();


  // calculate the renormalized probabilities for target sentence with length
  // TargetSentenceLength for given SourceSentenceLength
  virtual void PreparePr( int SourceSentenceLength, int TargetSentenceLength ) = 0;
  virtual void PrepareLogPr( int SourceSentenceLength, int TargetSentenceLength ) = 0;

  virtual void DisplayLogPr() = 0;

  // store & load alignment probabilities -----
  virtual bool Store( const char *pFileName ) = 0;
  virtual bool Load ( const char *pFileName ) = 0; 

protected:

  // sentence length of source and target sentence
  int m_SourceSLen;
  int m_TargetSLen;

};


#endif
