#include <string.h>
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdlib.h>
#include <fstream>
using std::ifstream;

#define NO_TRACE 1
#include <Trace.hh>

#include <Cognates.hh>

using namespace std;


void
CCognates::Init( const CVocabulary *pVocF, const CVocabulary *pVocE )
{
  m_pVocF = pVocF;
  m_pVocE = pVocE;

  m_IsCognateE.SetMaxIndex( m_pVocE->Size() );
  m_CognateF.SetMaxIndex( m_pVocF->Size() );
}


void
CCognates::FindCognates()
{
  assert(m_pVocE);
  assert(m_pVocF);

  Trace( 3, "Increase probability for cognates" );
  
  //m_TCounts->SetDefaultValue(0.0);
  
  for ( int i = 0; i < m_pVocE->Size(); i++ ) {
    for ( int j = 0; j < m_pVocF->Size(); j++ ) {
      double D = Distance(m_pVocE->GetWord( i ),
			  m_pVocF->GetWord( j ) );
      if (D == 0) {
	cout << m_pVocE->GetWord( i ) << " "
	     << m_pVocF->GetWord( j ) << " "
	     << D << endl;
	cout.flush();
	//m_pT->SetAt(i, j, 1000.0);
      }
    }
  }
  //m_pT->Renormalize();
}




double
CCognates::Distance(const char *S1, const char *S2)
{
  // words that begin with $
  if (S1[0] == '$' && S2[0] == '$' && strcmp(S1, S2) == 0)
    return 0.0;

  if (strlen(S1) < 4 || strlen(S2) < 4)
    return 1.0;

  if (strcmp(S1, S2) == 0)
    return 0.0;

  return 1.0;
}


BOOL
CCognates::Load( const char *filename )
{
  // char str[200];
  char CognateF[200];
  char CognateE[200];

  CWordIndex Wf, We;

  ifstream fp(filename);

  if (!fp) {
      cerr << "CCognates::Load(): Textfile " << filename
	   << " with Cognates could not be opened for read" << endl;
      return FALSE;
  }
  
  Trace( 1, "Load Cognates" );

  //fp.getline( str, 200 ); // Kommentarzeile

  //fp.getline( str, 200 );
  while (!fp.eof()) {
    fp >> CognateF >> CognateE;

    //Index = SearchWord( str );
    //cout << str << " " << Index << endl << flush;
    //if (Index > 0)
    //  isContentWord[Index] = TRUE;

    //fp.getline( str, 200 );
    
    Trace( 3, CognateF << " - " << CognateE );

    if ( (strlen( CognateF ) > 0) && (strlen( CognateE ) > 0) ) {
      We = m_pVocE->GetIndex( CString( CognateE ) );
      Trace( 5, m_IsCognateE[ We ] );
      m_IsCognateE[ We ] = TRUE;
      Wf = m_pVocF->GetIndex( CString( CognateF ) );
      m_CognateF[ We ] = Wf;

      Trace( 0, CognateF << " " << Wf << " - " << CognateE << " " << We);
    }
  }

  for ( We = 1; We < 100; We++ ) {
    Trace( 3, We << " " << m_IsCognateE[ We ] << " " << m_CognateF[ We ] );
  }
 
  return TRUE;
}

