#ifndef Cognates_hh
#define Cognates_hh

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif



//#include "String.hh"
#include <NumericalArray.hh>
#include <Vocabulary.hh>


typedef unsigned  int uint;

/*
typedef struct
{
  CWordIndex CognateF;
  CWordIndex CognateE;
} TCognatePair;
*/


class CCognates
{
public:
  CCognates() {};
  ~CCognates() {};

  void Init( const CVocabulary *pVocF, const CVocabulary *pVocE );

  // ----- Get Cognates
  BOOL IsCognateE( CWordIndex CognateE ) const;
  CWordIndex CognateF( CWordIndex CognateE ) const;

  // ----- Store & Load Cognate Pairs -----
  BOOL Store( const char *pFileName ) const;
  BOOL Load( const char *pFileName ); 

  void FindCognates();
  double Distance( const char *S1, const char *S2 );


private:
  //CArray< TCognatePair > m_Cognates;

  CNumericalArray< int > m_CognateF;
  CNumericalArray< BOOL > m_IsCognateE;

  const CVocabulary *m_pVocF;
  const CVocabulary *m_pVocE;

};



inline BOOL
CCognates::IsCognateE( CWordIndex CognateE ) const
{
  return m_IsCognateE[ CognateE ];
}


inline CWordIndex
CCognates::CognateF( CWordIndex CognateE ) const
{
  // Trace( 5, "CognateF " << CognateE << " " << m_CognateF[ CognateE ] );
  return m_CognateF[ CognateE ];
}


#endif
