#ifndef __FertilityModel__
#define __FertilityModel__

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif



//#include <iostream>
#include <Array.hh>
//#include <Text.hh>
#include <Vocabulary.hh>

class CFertilityModel
{
public:

  CFertilityModel();
  ~CFertilityModel();

  BOOL Init( CVocabulary *pVoc );

  //Load fertilty table from file
  //Format of the table 
  //    word p0 p1 p2 p3 p4
  //where p0=null fertility, p1=fertility 1,..and so on
  //currently hard coded to 5 values
  //BOOL LoadWithWords (const char* pFileName ); 
  BOOL Load( const char* pFileName ); 

  void Display();

  double Pr( CWordIndex windex, int k ) const;

  int GetMaxFertility();

  //CVocabulary GetInternalVoc();


private:

  int m_MaxFertility;			//maxiumu fertility value including zero length prob
  CMatrix <double> m_FertilityPr;  	//fertility table
  CVocabulary *m_pVoc;			//vocabulary; should be the same used in the decoder 	

  double m_DefaultFertilityPr;		//default prob. value for those OOV words

  //ARV 04/25
  //to know when we dont have a fertility value for a given word
  //CVocabulary* m_pInternalVoc;

  //Sanjika 07/12
  CWordIndex m_MaxWordIndex;		//max word index of the fertility table

}; 

#endif
