#include <config.h>

#include <algorithm>

#include <Segmenter.hh>


CSplitPoint::CSplitPoint()
{
  m_Sentence = -1;
  m_j = -1;
  m_i = -1;
  m_Score = 10000;
}


CSplitPoint::CSplitPoint( int s, int j, int i, double Score )
{
  m_Sentence = s;
  m_j = j;
  m_i = i;
  m_Score = Score;
}

CSplitPoint::CSplitPoint( const CSplitPoint &SplitPoint )
{
  m_Sentence = SplitPoint.m_Sentence;
  m_j = SplitPoint.m_j;
  m_i = SplitPoint.m_i;
  m_Score = SplitPoint.m_Score;
}

CSplitPoint &
CSplitPoint::operator = ( const CSplitPoint &SplitPoint )
{
  if ( this == &SplitPoint ) 
    return *this;

  m_Sentence = SplitPoint.m_Sentence;
  m_j = SplitPoint.m_j;
  m_i = SplitPoint.m_i;
  m_Score = SplitPoint.m_Score;

  return *this;
}


ostream& 
operator << ( ostream& OutStream, const CSplitPoint &SplitPoint  )
{
  OutStream << SplitPoint.m_Sentence << " " << SplitPoint.m_j 
	    << " " << SplitPoint.m_i << " " << SplitPoint.m_Score << endl;
  return OutStream;
}

/*
bool
operator < ( const CSplitPoint & First, const CSplitPoint & Second )
{
  return First.m_Score < Second.m_Score;
}

bool
CompareValue( const CSplitPoint & First, const CSplitPoint & Second )
{
  return First.m_Score < Second.m_Score;
}
*/


CSegmenter::CSegmenter()
{
  //m_pSegmenter = new CSegmenter;
}


CSegmenter::~CSegmenter()
{
  m_SplitPoints.clear();
}

			
const vector< CSplitPoint > & 
CSegmenter::SplitPoints()
{
  return m_SplitPoints;
}


void
CSegmenter::AddSplitPoint( CSplitPoint &SplitPoint )
{
  m_SplitPoints.push_back( SplitPoint );
}

void
CSegmenter::Resize( int NewSize )
{
  if ( m_SplitPoints.size() > NewSize ) {
    m_SplitPoints.resize( NewSize );
  }
}


void 
CSegmenter::SortToValue()
{
  sort( m_SplitPoints.begin(), m_SplitPoints.end(), CompareValue() );
}

void 
CSegmenter::SortToPosition()
{
  sort( m_SplitPoints.begin(), m_SplitPoints.end(), ComparePosition() );
}

void 
CSegmenter::Display()
{
  vector< CSplitPoint >::const_iterator Begin = m_SplitPoints.begin();
  vector< CSplitPoint >::const_iterator End = m_SplitPoints.end();
  vector< CSplitPoint >::const_iterator i;

  cout << endl;
  cout << "Segmentation Point: sentence, j, i, score" << endl;
  cout << "-----------------------------------------" << endl;
  //copy( Begin, End, ostream_iterator< int >( cout, " " ) );
  for ( i = Begin; i != End; ++i ) {
    cout << i->m_Sentence << " " << i->m_j << " " << i->m_i << " " << i->m_Score << endl;
  }
  cout << "-----------------------------------------" << endl;
  cout << endl;


}
