#include <config.h>

#ifndef __Segmenter__
#define __Segmenter__

#include <vector>
#include <functional>

#include <iostream>


using namespace std;


class CSplitPoint
{
public:

  CSplitPoint();
  CSplitPoint( const CSplitPoint &SplitPoint );
  CSplitPoint( int Sentence, int j, int i, double Score );
  
  CSplitPoint &operator = ( const CSplitPoint &SplitPoint );

  friend ostream& operator << ( ostream& os, const CSplitPoint &SplitPoint );
  //friend bool operator < ( const CSplitPoint &, const CSplitPoint & );
  //friend bool CompareValue( const CSplitPoint &, const CSplitPoint & );

  //protected:

  long m_Sentence;
  int m_j;
  int m_i;
  double m_Score;

  friend class CSegmenter;
};


//bool operator < ( const CSplitPoint &, const CSplitPoint & );


struct CompareValue : public binary_function< CSplitPoint, CSplitPoint, bool >
{
  bool operator()( const CSplitPoint &Sp1, const CSplitPoint &Sp2 ) 
    { 
      return Sp1.m_Score < Sp2.m_Score;
    }
};


struct ComparePosition : public binary_function< CSplitPoint, CSplitPoint, bool >
{
  bool operator()( const CSplitPoint &Sp1, const CSplitPoint &Sp2 )
  {
    return Sp1.m_Sentence < Sp2.m_Sentence;
  }
};


class CSegmenter
{
public:

  CSegmenter();
  ~CSegmenter();

  const vector< CSplitPoint > & SplitPoints();

  void AddSplitPoint( CSplitPoint &SplitPoint );
  void Resize( int NewSize );

  void SortToValue();
  void SortToPosition();

  void Display();


private:
  vector< CSplitPoint > m_SplitPoints;


};

  

#endif
