#include <stdlib.h>
#include <fstream>
using std::ifstream;
using std::ofstream;
#include <SentenceLengthModel.hh>

CSentenceLengthModel::CSentenceLengthModel() {
  //m_TargetLenPr = new CArray <double>;
  //m_pInternalVoc = new CVocabulary(); //do we need this in SLM?
  m_pFM = new CFertilityModel();
}

CSentenceLengthModel::~CSentenceLengthModel() {
  //delete m_pInternalVoc;
  delete m_pFM;
}

BOOL
//CSentenceLengthModel::Init(CVocabulary *pVoc) {
CSentenceLengthModel::Init(CVocabulary *pVoc, CFertilityModel *pFM) {
  m_pVoc = pVoc;
  m_pFM = pFM;
  //m_InternalVoc = m_pFM->GetInternalVoc();
  return TRUE;
}

/*

BOOL
//CSentenceLengthModel::LoadWithWords( const char* pFileName) {
CSentenceLengthModel::LoadFertilityTable( const char* pFileName) {

  //TODO: currently fixed to reading 5 values
  //generalize to any number of values

  //cerr << "Loading Fertility Table ... ";
  
  m_MaxFertility = 5;

  ifstream FFile(pFileName);
  
  if( !FFile ) {
    cerr << "File " << pFileName << " could not be opened" << endl;
    return FALSE;
    //exit(1);
  }


  //initialize the table with uniform prbs, for all words in the voc
  //this is necessary, to handle unknown words
  float uniprob = 1/(float)m_MaxFertility;
  m_DefaultFertilityPr = uniprob;
  //cout << "Uniprpob = " << uniprob << endl;

  //for(int i=0; i<m_pVoc->Size(); i++) {
  //  for(int j=0; j<m_MaxFertility; j++ ) {
  //    m_FertilityLogPr.SetAt(i, j, uniprob );   //init with uniform 
  //  }
  //}
  m_FertilityLogPr.SetBoundaries(0,m_pVoc->Size(),0,m_MaxFertility);
  m_FertilityLogPr.SetAll(uniprob);



  char *pWord = new char[256];
  double Pr[m_MaxFertility];
  CWordIndex WIndex;
  
  while( !FFile.eof() ) {

    FFile >> pWord >> Pr[0] >> Pr[1] >> Pr[2] >> Pr[3] >> Pr[4];
    //debug
    //cout << pWord << " " << Pr[0] << " " << Pr[1] << " " << Pr[2] << " " << Pr[3] << " " << Pr[4] << endl; 
  
    WIndex = m_pVoc->GetIndex( pWord );
    //ARV 04/25
    m_pInternalVoc->AddWord(CString(pWord));

    for(int i=0; i<m_MaxFertility; i++ ) {
      m_FertilityLogPr.SetAt(WIndex, i, Pr[i] );    //for the moment, Pr is stored.
    }

    //debug
    //cout << "Word = " << m_pVoc->GetWord( WIndex ) << endl;

  }
  
  cerr << "Done" << endl;

  return TRUE;
}


//debug
void
CSentenceLengthModel::DisplayFertilityTable() {

  cerr <<"Display Fertility Table" << endl;  
  
  m_FertilityLogPr.Display(); 

  cerr << "Done" << endl;

}


double
CSentenceLengthModel::FertilityPr( CWordIndex windex, int k ) const
{

  //ARV Sanjika 04/25 (switched this to use the static variables in the vocab
  if (windex==CVocabulary::EOT || windex==CVocabulary::UNK){
    //Trace( 3, " CSentenceLengthModel:: Word not found in fertility table. Using default fertility");
    return m_DefaultFertilityPr;
  }
  else {

    //Trace( 3, " CSentenceLengthModel:: Word found in fertility table.");
    return m_FertilityLogPr.GetAt(windex,k);
  }   
}

*/

void
CSentenceLengthModel::GenerateTargetLengthProbabilities(const CSentence *pSentence ) {

  //cerr << "Calculating Probabilities ... " << endl;

  int SentLength = pSentence->Length();
  CArray <double> T1,T2;  //previous step & current step
  CWordIndex WIndex;
  double FProb;

  int MaxFertility = m_pFM->GetMaxFertility();


  //debug
  //cerr << "Sentence Length = " << SentLength << endl;

  T1.SetBoundaries( 0, SentLength*(MaxFertility-1) );   
  T2.SetBoundaries( 0, SentLength*(MaxFertility-1) );

  //debug
  //cout << "Boundaries Set" << endl;
  //cout << "T1 size = " << T1.Size() << endl;
  //cout << "Max Fertility = " << MaxFertility << endl;
  
  T1.SetAll(0.0);  //initialize 
  T1[0] = 1.0; //starting prob = 1 for (1,0)



  for(int i=1; i<=SentLength; i++) { 
 
  //This is stranage!
  //In the sentences in decoder, actual words starts from 0
  //but if you used CSentence default, it starts at 1.
  //so had to change the loop accordingly  

  //TODO: set the loop indexes ccordingly!!!!!
  
  //for(int i=0; i<SentLength; i++) { 

    
    //ARV 04/25
    //changed to internal voc
    //WIndex = m_InternalVoc.GetIndex( pSentence->Word(i, m_pVoc) ); 
    //WIndex = m_pInternalVoc->GetIndex( pSentence->Word(i, m_pVoc) );  //this is round-about..
                                                              //since CSentence does not return word index
                                                              //see why there is no method for that
    WIndex = m_pVoc->GetIndex( pSentence->Word(i, m_pVoc) ); 

    //if(WIndex <= 0){ 
    //  cout << "Word " << pSentence->Word(i,m_pVoc) << " not found in the vocabulary!" << endl;
    //  exit(1);
    //}	
    //else {
    //  cout << "Index of the word " << pSentence->Word(i,m_pVoc) << " is : " << WIndex << endl;
    //}
    
    //cout << "Processing i = " << i << " word = ";

    //initialize result vector
    T2.SetAll(0.0);
    
    //debug	
    //cout << pSentence->Word(i,m_pVoc) << "\n";

   // for(int j=0; j<=(i-1)*MaxFertility; j++) {  //this loop should only run up to but not including
						//(i-1*MaxFertility. But if used that, when i=1 this
						//does not work (where it should iterate once. 
						//Therefore <= is used. This does not introduce any 
						//problem in later iterations since all the values
						//beyond (i-1)*MaxFertility in T1 are 0 (hence 0*FProb=0);

    //cerr << "i = " << i << " j = ";

    //int ubound = (i-1)*(MaxFertility-1);
    //cout << "Ubound of j = " << ubound << endl;

					
    //for(int j=0; j<=ubound; j++) { //this is better one
    for(int j=0; j<=(i-1)*(MaxFertility-1); j++) { //this is better one
    //for(int j=0; j<=(i*(MaxFertility-1)); j++) { //changed to suit the change in the index i

      //cerr << j << " ";
      //cerr << "MaxFert = " << MaxFertility << endl;
     
      for(int k=0; k<MaxFertility; k++) {

        //cout << "Reading Fertility at " << k << endl;

	//FProb = m_FertilityLogPr.GetAt(WIndex,k);   //error: if WIndex is a new word?
	//FProb = FertilityPr(WIndex,k);
	FProb = m_pFM->Pr(WIndex,k);

        //cout << " Done." << endl;
	//cout << "Calculating position " << j << " + " << k;

        T2[j+k] = T2[j+k] + T1[j]*FProb;

	//cout << " Done." << endl;
	
        //T2[j+k] = T1[j] +1 ;

        //debug 
        //cout << "i=" << i << " j=" << j << " k=" << k << endl;
	//cout << "T1 : ";
        //for(int l=0; l<T1.Size(); l++) {
	//  cout << T1[l] << " ";
        //}
        //cout << endl;

        //cout << "T2 : ";
        //for(int l=0; l<T2.Size(); l++) {
        //  cout << T2[l] << " ";
        //}
        //cout << endl;

      }
    }

    //cerr << endl;

    //cout << "Transferting T2 into T1";    

    T1 = T2;

    //cout << " Done." << endl;

  }

  m_TargetLenPr = T1;


  /*
  //debug
  double sum = 0;
  for(int k=0; k<m_TargetLenPr.Size(); k++ ) {
    sum += m_TargetLenPr[k];
  }
  cout << "Sum = " << sum << endl;
  */

  //find the max probable length 
  double MaxProb = 0.0;
  int BestLen = 0;
  for(int k=0; k<T1.Size(); k++ ) {
    if(T1[k] > MaxProb) {
      MaxProb = T1[k];
      BestLen = k;
    }
  }
  
  m_BestLength = BestLen;
 

  //cerr << "Done" << endl;
  
  //return BestLength;

}

double
CSentenceLengthModel::GetPr(const int HypLength ) {
  double Pr;
  if(HypLength>0 && m_TargetLenPr.Size()) {
    Pr = m_TargetLenPr[HypLength];
  }
  else {
    Pr = 0.0;
  }
  return Pr;
}


void
CSentenceLengthModel::Clear() {
  m_TargetLenPr.SetAll(0.0);
}

int 
CSentenceLengthModel::GetBestLength() {
  return m_BestLength;
}

