#ifndef SentenceLengthModel_hh
#define SentenceLengthModel_hh
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif



#include <iostream>
#include <Array.hh>
#include <Text.hh>
#include <Vocabulary.hh>
#include <FertilityModel.hh>

class CSentenceLengthModel
{
public:

  CSentenceLengthModel();
  ~CSentenceLengthModel();

  BOOL Init(CVocabulary *pVoc, CFertilityModel *pFM);

  //Load fertilty table from file
  //Format of the table 
  //    word p0 p1 p2 p3 p4
  //where p0=null fertility, p1=fertility 1,..and so on
  //currently hard coded to 5 values
  //BOOL LoadWithWords (const char* pFileName ); 
  //BOOL LoadFertilityTable (const char* pFileName ); 

  //void DisplayFertilityTable();

  void GenerateTargetLengthProbabilities(const CSentence *pSentence );

  double GetPr(const int HypLenth );

  void Clear();

  int GetBestLength();

  //double FertilityPr( CWordIndex windex, int k ) const;


private:

  CFertilityModel *m_pFM; 

  //int m_MaxFertility;			//maxiumu fertility value including zero length prob
  //CMatrix <double> m_FertilityLogPr;  	//fertility table
  CVocabulary *m_pVoc;			//vocabulary; should be the same used in the decoder 	

  CArray <double> m_TargetLenPr;	//prob. of target lengths for the current source sent.
  int m_BestLength;			//best length for the current source sent.
  //double m_DefaultFertilityPr;		//default prob. value for those OOV words

  //ARV 04/25
  //to know when we dont have a fertility value for a given word
  //CVocabulary m_InternalVoc;
}; 

#endif
