#ifndef MapWordToTag_hh
#define MapWordToTag_hh


#include <iostream>
#include <NumericalArray.hh>
#include <Vocabulary.hh>

// CMapWordToTag
// Class for Mappting Words to a Tag (used in Phrase Alignment)



class CMapWordToTag
{
public:
  CMapWordToTag();
  ~CMapWordToTag();

  //Loads Vocabulary of Words and of Tags
  bool Init(CVocabulary *wordVoc, CVocabulary *tagVoc);

  //Gets a Stream to file, that contains mapping from Word to Tag
  //In every row first word and after that TAG
  bool Load(std::istream *InStream);
  
  //Returns the CWordIndex of a Tag when given a CWordIndex of a Word
  CWordIndex getTag(CWordIndex WordIndex);


private:

  // Contains the Mapping Word -> Tag
  CNumericalArray<CWordIndex> tags;
  
  //Vocabulary of words
  CVocabulary *wordVoc;
  
  //Vocabulary of Tags
  CVocabulary *tagVoc;


};
#endif
