//           Format.cxx
//  Sat Jul 25 00:55:34 2009
//  Copyright  2009  qing
//  <qing@<host>>

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA

#include "Format.h"
#include "SimpleLogger.h"
#include <fstream>

using namespace std;
namespace qformat{

	bool CQFileFormat::OpenFile(const char* fname){
		D_DEBUG_VERBOSE(10,"%s",fname);
		A_FATAL(fname!=NULL);
		filename = fname;
		is_stream.open(fname);
		C_WARN(is_stream.is_open());
	}

	void CQFileFormat::CloseFile(){
		if(is_stream.is_open()){
			is_stream.close();
		}else{
			P_WARN("Closing a stream that does not open.");
		}
	}

	bool CQFileFormat::Rewind(){
		if(is_stream.is_open ()){
			is_stream.seekg(0,ios_base::beg); // Set pointer to beginning
		}else{
			P_WARN("Trying to rewind a stream that is not open");
		}
	}
}
