//           Sentence.cxx
//  Thu Jul 23 23:24:16 2009
//  Copyright  2009  qing
//  <qing@<host>>

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA

#include "Sentence.h"
#include "SimpleLogger.h"

namespace qformat{

	size_t CQSentence::GetLength() const {
		return words.size();
	}

	const CQWord& CQSentence::GetWord(size_t idx) const{
		// If idx < 0 return first, if idx >= size(), return last 
		if(idx <0){
			P_WARN("Access word out-of-boundary Sentence Length: %d Asking for "
			       "Entry Index: %d ", words.size(),idx);
			return words[0];
		}
		else if (idx >= words.size()){
			P_WARN("Access word out-of-boundary Sentence Length: %d Asking for "
			       "Entry Index: %d ", words.size(),idx);
			return words[words.size()];
		}else{
			P_DEBUG_VERBOSE(10,"Asking for %d of %d words, value is %s",
			                idx,words.size(),words[idx].GetString());
			return words[idx];
		}
	}

	void CQSentence::AddWord(const char* rep){
		P_DEBUG_VERBOSE(10,"Adding word %s, before adding, length is %d",
		                rep,words.size());
		words.push_back(CQWord(rep,this,words.size()));
		P_DEBUG_VERBOSE(10,"Adding word %s, after adding, length is %d",
		                rep,words.size());
		
	}
	
}