/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */

#include "BasePhraseExtraction.h"
#include "SwirlSRLFormat.h"
#include <boost/shared_ptr.hpp>
#include <iostream>
#include <fstream>

#ifndef __SRL_PHRASE_EXTRACTION__
#define __SRL_PHRASE_EXTRACTION__
namespace qphrase{
	class PhraseAppenderWithSRL : public PhraseAppender{
		private:
			mutable qformat::CQSwirlSRLFormat srlinput;
			mutable std::string stroutputfile;
			mutable bool disablefl;
			mutable size_t phrasecount;
			mutable std::ofstream phraseoutput;
			mutable boost::shared_ptr<qformat::CQSRLSentence> curr;
		public:
			/// Open the swirl input file
			PhraseAppenderWithSRL(const char* inputfile,const char* outputfile,
			                      bool disableFileLimit = false);
			virtual ~PhraseAppenderWithSRL(){};
		public:
			virtual void operator()
				(SentenceAlignment &, int, int, int, int);

		virtual void StartSentence(size_t srcSize, size_t tarSize);
		virtual void EndSentence();			
	};
}
#endif

